<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.22.2.30.2.56 $
 * $Author: tora60 $
 * $Date: 2012-03-12 23:25:19 $
 */

define('mxAdminFileLoaded', true);

if (!defined('MX_TIME')) {
    define('MX_TIME', microtime(true));
}
// einen Modulnamen verpassen
define('MX_MODULE', 'admin');
// nur zum initialisieren der Variablen, wird durch das Modul ueberschrieben
$GLOBALS['index'] = 0;
// PHP_SELF macht auf manchen Servern Probleme bei mod_rewrite,
// es wird die umgeschriebene URL verwendet anstatt modules.php
// deshalb hier umschreiben
$_SERVER['PHP_SELF'] = preg_replace('#^[\\\\/]+#', '/', dirname($_SERVER['PHP_SELF']) . '/' . basename(__file__));
// Jeder Adminkategorie einen Namen verpassen...
define('MX_ADMINPANEL_SYSTEM', 1);
define('MX_ADMINPANEL_CONTENT', 2);
define('MX_ADMINPANEL_SECURITY', 3);
define('MX_ADMINPANEL_USERS', 4);
define('MX_ADMINPANEL_ADDON', 5);
define('PMX_SYSADMIN_NAME', 'God');

/**
 * pragmaMx Hauptdatei includen
 */
require_once('mainfile.php');

mxGetLangfile('admin');

if (!isset($show_pragmamx_news)) $show_pragmamx_news = 1; // falls noch gespeichert > einschalten
define('adminpragmamxinfourl', 'http://www.pragmamx.org/infonews.php?v=' . urlencode(PMX_VERSION_NUM) . '&amp;lang=' . urlencode($GLOBALS['currentlang']) . '');

$pagetitle = _ADMINMENU;

/* Admintabs abschalten, wenn kein God-Admin, um zu verhindern dass unntig leere Tabs angezeigt werden */
if ($GLOBALS['adminpanel'] && !mxGetAdminPref('radminsuper')) {
    $GLOBALS['adminpanel'] = false;
}

/**
 */
function login()
{
    mt_srand((double)microtime() * 1000000);
    $xcv = mt_rand();
    mxSessionSetVar('reqcheck', $xcv);
    $formmessage = mxSessionGetVar('formmessage');
    mxSessionDelVar('formmessage');

    include ("header.php");
    OpenTable();
    if ($formmessage) {
        echo "<br />" . $formmessage . "<br /><br />";
    }
    echo "<form action=\"admin.php\" method=\"post\" name=\"adminlogin\">"
     . "<fieldset><legend>" . _ADMINLOGIN . "</legend>"
     . "<table class=\"form\">"
     . "<tr><td>" . _ADMINID . "</td>"
     . "<td><input type=\"text\" name=\"aid\" size=\"30\" maxlength=\"25\" /></td></tr>"
     . "<tr><td>" . _PASSWORD . "</td>"
     . "<td><input type=\"password\" name=\"pwd\" size=\"30\" /></td></tr>"
     . "<tr><td>&nbsp;</td><td>"
     . "<input type=\"hidden\" name=\"op\" value=\"login\" />"
     . "<input type=\"hidden\" name=\"check\" value=\"" . MD5($xcv) . "\" />"
     . "<input type=\"hidden\" name=\"sess\" value=\"" . MD5(session_id()) . "\" />"
     . "<input type=\"hidden\" name=\"uri\" value=\"" . base64_encode(PMX_HOME_URL . $_SERVER["REQUEST_URI"]) . "\" />"
     . "<input type=\"submit\" value=\"" . _LOGIN . "\" />"
     . "</td></tr></table>"
     . "</fieldset></form>";
    echo "<script type='text/javascript'>\n<!--\ndocument.adminlogin.aid.focus();\n//-->\n</script>";
    CloseTable();
    include ("footer.php");
}

/**
 * das eigentliche login
 */
function mx_sys_adminlogin($pvs)
{
    global $prefix, $user_prefix;

    $defaults = array('aid' => '', 'pwd' => '', 'op' => '', 'check' => '', 'sess' => '', 'uri' => '');
    $pvs = array_merge($defaults, $pvs);

    $abad = intval(mxSessionGetVar('abad'));
    $pvs['check'] = (empty ($pvs['check'])) ? mt_rand() : $pvs['check']; // sicherstellen, dass $check initialisiert ist
    $welcome = 'admin.php?op=welcome';
    $real_uri = '';
    if (!empty ($pvs['uri'])) {
        $real_uri = mxSecureValue(base64_decode($pvs['uri']), true);
        if (preg_match('#^' . preg_quote(PMX_HOME_URL) . '(/.*)?#', $real_uri, $matches)) {
            if (!preg_match('#nextlogin_#', $matches[1])) {
                $welcome = $matches[1];
            }
        } else {
            $baduri = true;
        }
    }
    if (md5(session_id()) != $pvs['sess']) {
        $msg = "<br /><b>" . _ADMIN_BADLOGIN4 . "</b><br />";
        mxErrorScreen(_ADMIN_BADLOGIN4);
        die();
    } else if (empty ($pvs["aid"]) || empty ($pvs["pwd"])) {
        $msg = "<b>" . _ADMIN_BADLOGIN . "!</b><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . _ADMIN_BADLOGIN2 . "<br />";
        mxSessionSetVar("formmessage", $msg);
        $location = "admin.php?op=nextlogin_" . $abad;
    } else if (($pvs["check"] != MD5(mxSessionGetVar("reqcheck"))) || (strlen($pvs["aid"]) > 25)) {
        // sofort intruder
        $doblock = 1;
        mxYoubad("Bad Adminlogin - Account: " . $pvs["aid"] . " (no session-check-id)");
        die();
    } else if (empty($pvs["uri"]) || isset($baduri)) {
        // sofort intruder
        $doblock = 0;
        mxYoubad("Bad Adminlogin - Account: " . $pvs["aid"] . " (bad Referer: " . $real_uri . ")");
        die();
    } else {
        $pwd = md5($pvs["pwd"]);
        $qry = "SELECT a.aid AS aid, a.pwd AS pwd, u.*
						          FROM ${prefix}_authors AS a
											LEFT JOIN {$user_prefix}_users AS u
											ON a.user_uid = u.uid
						          WHERE (a.aid='" . mxAddSlashesForSQL(substr($pvs["aid"], 0, 25)) . "');";
        $result = sql_query($qry);
        $adminrow = sql_fetch_array($result);
        if ($adminrow['pwd'] != $pwd) {
            if ($abad > 3)
                mxSecureLog("SecLog", "Bad Adminlogin - Account: " . $pvs["aid"]);
            mxSessionSetVar("abad", $abad + 1);
            $msg = "<b>" . _ADMIN_BADLOGIN . "!</b><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . _ADMIN_BADLOGIN2 . "<br />";
            mxSessionSetVar("formmessage", $msg);
            $location = "admin.php?op=nextlogin_" . $abad;
        } else {
            $info = base64_encode($adminrow['aid'] . ':' . $adminrow['pwd'] . ':'); // dritter Parameter leer, war admlanguage
            mxSessionSafeCookie(MX_SAFECOOKIE_NAME_ADMIN, 1);
            mxSetNukeCookie("admin", $info, 1);
            mxSessionSetVar("admin", $info);
            mxSessionDelVar("abad");
            mxSessionDelVar("formmessage");
            if (empty ($adminrow['uid']) || $adminrow['user_stat'] != 1) {
                $location = "admin.php?op=adminMain";
            } else {
                // setzt den neuen user-cookie
                mxSetUserSession($adminrow["uid"], $adminrow["uname"], $adminrow["pass"], $adminrow["storynum"], $adminrow["umode"], $adminrow["uorder"], $adminrow["thold"], $adminrow["noscore"], $adminrow["ublockon"], $adminrow["theme"], $adminrow["commentmax"]);
                mxSessionSetVar('lang', $adminrow['user_lang']);
                $location = $welcome;
            }
        }
    }
    if ($abad > 8) {
        mxSessionSetVar("abad", $abad -2);
        mxYoubad("Bad Adminlogin - Account: " . $pvs["aid"] . " (bad " . ($abad + 2) . "))");
    }
    mxSessionDelVar("reqcheck");
    mxSessionSetVar("lasttime", 0); // Zuruecksetzen, damit Online ausgefuehrt wird
    mxRedirect($location);
    exit;
}

/* Navigationsfunktionen  BEGIN */
function mxAdminGetNav()
{
    $nav_item = array(1 => array('url' => 'admin.php?panel=system',
            'class' => 'tabs-nav-sys',
            'title' => _SYSTEM,
            'description' => _SYSTEM_DESCR,
            ),
        2 => array('url' => "admin.php?panel=content",
            'class' => 'tabs-nav-con',
            'title' => _CONTENT,
            'description' => _CONTENT_DESCR,
            ),
        3 => array('url' => "admin.php?panel=security",
            'class' => 'tabs-nav-sec',
            'title' => _SECURITY,
            'description' => _SECURITY_DESCR,
            ),
        4 => array('url' => "admin.php?panel=users",
            'class' => 'tabs-nav-use',
            'title' => _USERS,
            'description' => _USER_DESCR,
            ),
        5 => array('url' => "admin.php?panel=addon",
            'class' => 'tabs-nav-add',
            'title' => _ADDON,
            'description' => _ADDON_DESCR,
            ),
        );
    return $nav_item;
}

function adminmenu($url, $title, $image, $panel = MX_ADMINPANEL_ADDON)
{
    global $thelinks;
    if ($GLOBALS['adminpanel']) {
        $thelinks[$panel][strtolower($title . $url)] = array('url' => $url,
            'title' => $title,
            'image' => $image,
            );
    } else {
        $thelinks[strtolower($title . $url)] = array('url' => $url,
            'title' => $title,
            'image' => $image,
            );
    }
}

function mxAdminGetLinks($panel = MX_ADMINPANEL_SYSTEM)
{
    global $aid, $admingraphic, $banners, $prefix, $op;
    global $thelinks; # temporaere Variable erstellen, wird in adminmenu() veraendert

    if (empty($op)) {
        $op = "adminMain";
    }

    /* die Daten von $admindata werden in den .link-Dateien benoetigt */
    $admindata = mxGetAdminData();
    extract($admindata);

    /* alle .link Dateien einlesen */
    $cacheid = 'adminlinks' . $aid . $GLOBALS['currentlang'] . $GLOBALS['adminpanel'];
    $cache = load_class('Cache');
    if (($thelinks = $cache->read($cacheid)) === false) {
        $thelinks = array();
        foreach ((array)glob(PMX_ADMIN_DIR . DS . 'links' . DS . 'links.*.php', GLOB_NOSORT) as $filename) {
            /* Datei einlesen, hier wird jeweils die funktion adminmenu() ausgefuehrt */
            if ($filename) {
                include_once($filename);
            }
        }
        $cache->write($thelinks, $cacheid);
    }

    if ($GLOBALS['adminpanel']) {
        if (!isset($thelinks[$panel])) {
            return '';
        }
        /* wenn Panel verwendet, nur die Links des aktiven Panels verwenden */
        $thelinks = $thelinks[$panel];
    }
    /* alphabetisch sortieren */
    ksort($thelinks);

    /* Rueckgabearry initialisieren */
    $html = array();
    /* Rueckgabearry fuellen */
    foreach ($thelinks as $link) {
        /* mit Grafik, oder nicht ? >> HTML-Ausgabe fuer Link zusammenstellen*/
        if ($GLOBALS['admingraphic']) {
            $html[] = '<a href="' . $link['url'] . '" class="item" style="background-image: url(images/admin/' . $link['image'] . ');">' . $link['title'] . '</a>';
        } else {
            $html[] = '<a href="' . $link['url'] . '" class="item text">' . $link['title'] . '</a>';
        }
    }
    /* clearing fuer float noch anhaengen */
    $html[] = '<div style="clear: both;"></div>';
    /* raus damit */
    return implode("\n", $html);
}

function mxAdminGetPanelVal()
{
    $array = array('choice' => 0, 'descr' => "");
    $sess_var = mxSessionGetVar('panel');
    $panel_sv = !empty($sess_var) ? $sess_var : "system";
    if (isset($_GET['op']) && $_GET['op'] == 'DisplayStory' && isset($_GET['qid'])) {
        $_GET['panel'] = "content";
    }
    $panel = empty($_GET['panel']) ? $panel_sv : $_GET['panel'];
    if (!intval($panel) > 0) {
        switch ($panel) {
            case 'content' : $choice = 2;
                $descr = _CONTENT_DESCR;
                break;
            case 'security' : $choice = 3;
                $descr = _SECURITY_DESCR;
                break;
            case 'users' : $choice = 4;
                $descr = _USER_DESCR;
                break;
            case 'addon' : $choice = 5;
                $descr = _ADDON_DESCR;
                break;
            default : $choice = 1;
                $descr = _SYSTEM_DESCR;
                break;
        }
    } else {
        $choice = $panel;
        $descr = isset($_GET['ok']) ? _SYSTEM_DESCR : "";
    }
    if (!isset($_GET['op']) && !isset($_GET['panel']) && empty($sess_var)) {
        $choice = 1;
        $descr = _SYSTEM_DESCR;
    }
    $array['choice'] = $choice;
    $array['descr'] = $descr;
    return $array;
}

function GraphicAdmin()
{
    OpenTable();
    echo '<div align="center" id="graphicadmin">';
    if (empty($GLOBALS['adminpanel'])) {
        $panel = 0;
        if (defined('MX_DEMOMODE_RUN')) {
            echo '<div class="warning"><strong>' . _DEMOMODEACTIV . '</strong></div>';
        }
        echo mxAdminGetLinks(0);
    } else {
        $items = array();
        $choice = 1;
        extract(mxAdminGetPanelVal()); // hier kommt $choice zustande
        mxSessionSetVar('panel', $choice);
        $nav_items = mxAdminGetNav();
        $nav_items[$choice]['class'] .= ' current';
        foreach ($nav_items as $item) {
            $items[] = '<li class="' . $item['class'] . '"><a href="' . $item['url'] . '" title="' . $item['description'] . '" onfocus="this.blur()">' . $item['title'] . '</a></li>';
        }
        $items = implode("\n", $items);

        ?>
<ul class="tabs-nav"><?php echo $items ?></ul>
<div class="tabs-panel"><div>
<?php
        // der leere <div> Tag wird fuer den IE benoetigt, weil sonst der
        // Rahmen von tabs-panel nicht korrekt dargestellt wird
        if (defined('MX_DEMOMODE_RUN')) {
            echo '<div class="warning"><strong>' . _DEMOMODEACTIV . '</strong></div>';
        }
        echo mxAdminGetLinks($choice);

        ?>
<div style="clear: both;"></div>
</div>
</div>
  	 <?php
    }
    echo '</div>';
    CloseTable();
    echo '<br />';
}

/**
 * adminMain()
 * das Hauptmenue des Adminbereiches
 *
 * @return
 */
function adminMain()
{
    global $prefix, $user_prefix, $sitename, $show_pragmamx_news, $check_chmods;

    /* weitere Infos, nur im System-Tab anzeigen */
    if ($GLOBALS['adminpanel'] == '1') {
        $pan = mxAdminGetPanelVal();
        if ($pan['choice'] != 1) {
            include ('header.php');
            GraphicAdmin();
            include ('footer.php');
            return;
        }
    }

    $shownews = '';
    $err_dir = '';
    $err_file = '';

    if ($check_chmods) {
        $err_dir = array();
        $err_file = array();
        admin_chmods::check($err_dir, $err_file);
    }

    $admindata = mxGetAdminData();
    $result = array();
    pmx_run_hook('admin.newentries', $admindata, $result);

    $content1 = '';
    foreach ($result as $entry) {
        $content1 .= '<li class="nowrap"><b>' . mxValueToString($entry['count'], 0) . '</b> <a href="' . $entry['link'] . '">' . $entry['text'] . '</a></li>';
    }

    if ($content1) {
        $shownews .= '<div class="box">
            <h3>' . _NEWSUBMISSIONS . '</h3>
            <ul class="infolist align-left">
                ' . $content1 . '
            </ul></div>';
    } else {
        $shownews .= '<h3 class="note align-center">' . _NOSUBMISSIONS . '</h3>';
    }

    $shownews .= '
        <ul class="tabs-nav-secondary">
            <li><a href="admin.php?op=resetPmxCache">' . _RESETPMXCACHE . '</a></li>
            <li><a href="admin.php?op=mxvcheck">' . _VERSIONCHECK . '</a></li>
            <li><a href="http://www.pragmamx.org/doku.php" target="_blank">' . _ONLINEMANUAL . '</a></li>
            <li><a href="admin.php?op=logout">' . _ADMINLOGOUT . '</a></li>
        </ul>';

    if ($check_chmods && ($err_dir || $err_file)) {
        $shownews .= '<div class="warning">
            <p>' . _FALSECHMODS1 . '</p>
            <ul class="align-left">
                <li>' . implode('</li><li>', array_merge($err_file, $err_dir)) . '</li>
            </ul>
            </div><br />';
    }

    if ($show_pragmamx_news) {
        $shownews .= '<div class="box"><h3>' . _PRAGMANEWS . '</h3><iframe src="' . adminpragmamxinfourl . '" name="Infonews" id="Infonews" width="100%" height="100" marginwidth="3" marginheight="3" frameborder="0" class="border"><a href="' . adminpragmamxinfourl . '" target="_blank"><strong>' . _SHOWPRAGMANEWS . '</strong></a></iframe></div>';
    } else {
        $shownews .= '<p class="box"><a href="' . adminpragmamxinfourl . '" target="_blank"><strong>' . _SHOWPRAGMANEWS . '</strong></a></p>';
    }
    $infolink = (mxGetAdminPref('radminsuper')) ? '&nbsp;&nbsp;<span class="tiny">(<a href="admin.php?op=info" title="PHP-Info">PHP-Info</a>)</span>' : '';

    include('header.php');
    GraphicAdmin();

    echo '
        <div class="float-right" style="width:33%">
		    <dl>
		        <dt>' . _VERSION_CMS . ':</dt>
		        <dd>pragmaMx ' . PMX_VERSION_NUM . ' (' . PMX_VERSION_DATE . ')</dd>
            </dl>
		    <dl>
		       	<dt>' . _VERSION_PHP . ':</dt>
        		<dd>' . phpversion() . $infolink . '</dd>
		    </dl>
            <dl>
		      	<dt>' . _VERSION_MYSQL . ':</dt>
		       	<dd>' . MX_SQL_VERSION . '</dd>
            </dl>
            <dl>
		       	<dt>' . _VERSION_SERVER . ':</dt>
		       	<dd>' . $_SERVER['SERVER_SOFTWARE'] . '</dd>
		    </dl>
        </div>
        <div class="float-left" style="width:60%">
		    ' . $shownews . '
        </div><br class="clear"/>';

    include ('footer.php');
}

/* deprecated! use mxLanguageSelect instead! */
function mxAdminLanguageSelect($selectname, $curlang = "", $hideall = 0)
{
    trigger_error('Use of deprecated function mxAdminLanguageSelect(), use mxLanguageSelect() instead.', E_USER_NOTICE);
    return mxLanguageSelect($selectname, $curlang, 'language', 1);
}

function admindologout()
{
    mxSessionSafeCookie(MX_SAFECOOKIE_NAME_ADMIN, 0);
    mxSetNukeCookie("admin");
    mxSessionDelVar("admin");
    if (!MX_IS_USER) {
        mxSessionDestroy();
    } else {
        session_write_close();
    }
    mxRedirect(PMX_HOME_URL . "/admin.php?op=logoutfin");
}

function admindologoutfin()
{
    mxSessionDelVar("admin");
    mxSessionSetVar("lasttime", 0); // Zuruecksetzen, damit Online ausgefuehrt wird
    mxRedirect('index.php', _YOUARELOGGEDOUT);
}

function getCheckUsersSelectOptions($user_stat = 0)
{
    global $user_prefix, $prefix;
    $user_stat = (int)$user_stat;
    $errmsg = (empty($user_stat)) ? "No New Users available" : "No deactivated Users available";
    $useroptions = "";
    $qry = "SELECT uname, uid
					FROM {$user_prefix}_users
					WHERE {$user_prefix}_users.user_stat = " . $user_stat . "
					ORDER BY {$user_prefix}_users.uname";
    $result = sql_query($qry);
    if ($result) {
        while (list($uname, $uid) = sql_fetch_row($result)) {
            $useroptions .= "<option value=\"" . $uid . "\">" . $uname . "</option>\n";
        }
    }
    $useroptions = (empty($useroptions)) ? "<option value=0>" . $errmsg . "</option>" : $useroptions;
    return $useroptions;
}

function getAllUsersSelectOptions2($currentgroup)
{
    global $user_prefix, $prefix;
    $useroptions = "";
    $qry = "SELECT uname
	        FROM {$user_prefix}_users
					WHERE user_ingroup=" . $currentgroup . " AND user_stat=1
					ORDER BY uname";
    $result = sql_query($qry);
    if ($result) {
        while (list($uname) = sql_fetch_row($result)) {
            $useroptions .= "<option value=\"" . $uname . "\">" . $uname . "</option>";
        }
    }
    $useroptions = (empty($useroptions)) ? "<option value=0>ERROR!!! No Users available</option>" : $useroptions;
    return $useroptions;
}

function getAllAccessLevelSelectOptions($selectedgroup)
{
    global $prefix;

    $userconfig = load_class('Userconfig');
    // Sicherstellen, dass wirklich eine Gruppe vorselektiert werden kann
    if (empty($selectedgroup)) {
        $selectedgroup = array(intval($userconfig->default_group));
    } else if (!is_array($selectedgroup)) {
        $selectedgroup = array(intval($selectedgroup));
    }
    if (empty($selectedgroup[0])) {
        $selectedgroup = array(intval($userconfig->default_group));
    }
    // alle Gruppen auslesen
    $groups = getAllAccessGroups(true);
    // die Optionen zusammenstellen
    foreach ($groups as $key => $row) {
        if ($userconfig->default_group == $row['access_id']) {
            $row['access_title'] .= '&nbsp;*';
        }
        $sel = (in_array($row['access_id'], $selectedgroup)) ? ' selected="selected" class="current"' : '';
        $groupoptions[] = '<option value="' . $row['access_id'] . '"' . $sel . '>' . $row['access_title'] . '</option>';
    }
    // wenn Optionen vorhanden, ansonsten Fehler
    if (isset($groupoptions)) {
        return "\n" . implode("\n", $groupoptions) . "\n";
    } else {
        return '<option value="0">ERROR!!! No Groups available</option>';
    }
}

function create_first($pvs)
{
    global $prefix, $user_prefix;
    extract($pvs);

    if (!isset($_COOKIE[MX_SESSION_NAME])) {
        // wenn kein Session-Cookie gesetzt wurde
        mxErrorScreen(_ADMIN_BADLOGIN4);
    }
    if (!mxSessionGetVar("create_first") || empty($first_check)) {
        // wenn session bereits geloescht (z.B. bei refresh der page)
        // oder Check-Variable des Formulars fehlt, umleiten
        mxRedirect(PMX_HOME_URL . '/admin.php');
    }

    $first_name = substr($first_name, 0, 25);
    // wenn die Funktion nicht ueber das richtige Formular aufgerufen:
    // Intruder und Session blockieren (funktion: vkpIpBanning() in header.php)
    $checkID = md5(mxSessionGetVar("create_first"));
    mxSessionDelVar("create_first");
    if ($first_check != $checkID) {
        $doblock = 1;
        mxYoubad("create_first failed (no session-check-id) - $first_name");
        die();
    }
    // pruefen ob vielleicht doch schon ein God-Account besteht
    $result = sql_query("SELECT count(aid) FROM ${prefix}_authors where name ='" . PMX_SYSADMIN_NAME . "'");
    list($first) = sql_fetch_row($result);
    if ($first == 1) {
        // wenn doch schon einer da ist...
        mxSecureLog("SecLog", "create_first failed (is available) - $first_name");
        mxErrorScreen(_ADMIN_GODEXIST);
    }
    // pruefen ob der Adminname bereits vergeben ist
    $result = sql_query("SELECT count(aid) FROM ${prefix}_authors where aid ='" . mxAddSlashesForSQL($first_name) . "'");
    list($aexist) = sql_fetch_row($result);
    if (!empty($aexist)) {
        $pvs['msg'] = _UANICKTAKEN . " (" . $first_name . ")";
        unset($pvs['first_name']);
    }
    // nicht alle Felder ausgefuellt?
    else if (empty($first_name) || empty($first_email) || empty($first_pwd) || mxCheckNickname($first_name) !== true) {
        $pvs['msg'] = _COMPLETEFIELDS;
    }
    // pruefen ob der Adminname in der Liste mit gesperrten/gebannten Namen steht
    $result = sql_query("SELECT ban_val FROM ${prefix}_user_ban where ban_type='ban_name'");
    $ban_name = array();
    while (list($ban_val) = sql_fetch_row($result)) {
        $ban_name[] = $ban_val;
    }
    if (in_array(strtolower($first_name), $ban_name)) {
        $pvs['msg'] = sprintf(_UAERRORNICKBANN, $first_name);
        unset($pvs['first_name']);
    }
    // pruefen ob der Adminname in der Liste mit zensierten Woerter steht
    // Da der eingegebene Name an dieser Stelle bereits durch die Zensurfunktion
    // ersetzt wurde, kann nur noch gegen das Ersetzungswort aus der Konfiguration
    // getestet werden.
    else if ($first_name == $GLOBALS['CensorReplace']) {
        $pvs['msg'] = sprintf(_UAERRORNICKCENSOR, $first_name);
        unset($pvs['first_name']);
    }
    // Datenbankpasswort zur Sicherheit ueberpruefen
    // wer das nicht kennt, kann auch kein God sein
    else if ($first_dbpass != $GLOBALS['dbpass']) {
        mxSecureLog("SecLog", "create_first failed (bad dbPass) - $first_name");
        $pvs['msg'] = _ADMIN_ERRDBPASS;
        unset($pvs['first_dbpass']);
    }
    // wenn Fehler-Message, Seite neu aufrufen
    if (isset($pvs['msg'])) {
        // uebergebene Parameter und Fehler-Message in Session schreiben
        mxSessionSetVar("first_data", $pvs);
        session_write_close();
        mxRedirect(PMX_HOME_URL . '/admin.php');
        exit;
    }
    // Daten in Admintabelle schreiben
    $first_pwd = md5(trim($first_pwd));
    $qry = "INSERT INTO ${prefix}_authors ( aid, name, url, email, pwd, counter, radminsuper )
					VALUES ( '" . mxAddSlashesForSQL($first_name) . "', '" . mxAddSlashesForSQL(PMX_SYSADMIN_NAME) . "', '" . mxAddSlashesForSQL($first_url) . "', '" . mxAddSlashesForSQL($first_email) . "', '$first_pwd', 0, 1);";
    $result = sql_query($qry);
    // wenn beim schreiben Fehler aufgetreten
    if (!$result) {
        mxErrorScreen(_ADMIN_ERRSQL . "<br /><br />$qry");
    }
    // Soll ein normaler User miterstellt werden?
    if ($first_createuser) {
        // pruefen ob Benutzername bereits vorhanden
        $result = sql_query("select uid from {$user_prefix}_users where uname='" . mxAddSlashesForSQL($first_name) . "'");
        list($uid) = sql_fetch_row($result);
        if (!$uid) {
            // wenn nein, neuen Benutzer anlegen
            $user_regdate = mxGetNukeUserregdate();
            $user_regtime = time();
            $qry = "INSERT INTO {$user_prefix}_users
              			( uname       , name         , email         , url         , pass        , user_regdate   , user_regtime , user_stat) values
              			('$first_name', '" . mxAddSlashesForSQL($first_name) . "', '" . mxAddSlashesForSQL($first_email) . "', '" . mxAddSlashesForSQL($first_url) . "', '$first_pwd', '$user_regdate', $user_regtime, 1);";
            $result = sql_query($qry);
            if ($result) {
                /* wenn erfolgreich, eingefuegte uid  ermitteln */
                $uid = sql_insert_id();
                /* Modulspezifische Useranfgungen durchfuehren */
                pmx_run_hook('user.add', $uid);
            }
        }
        // wenn eine gueltige uid vorhanden ist,
        if ($uid) {
            // diese in die Admintabelle zur Verknuepfung eintragen (selfadmin)
            sql_query("UPDATE ${prefix}_authors SET user_uid=" . intval($uid) . " WHERE aid='" . mxAddSlashesForSQL($first_name) . "'");
        }
    }
    mxSecureLog("SecLog", "create_first: ok - $first_name");
    // Erfolgsnachricht in Session schreiben
    $msg = "<b>" . _ADMIN_GODCREATEOK . "</b><br /><br /><b>" . _UAASADMIN . "</b>: $first_name<br /><b>" . _UAASUSER . "</b>: $first_name";
    mxSessionSetVar("formmessage", $msg);
    mxSessionDelVar("first_data");
    session_write_close();
    // und ab zum login :-))
    mxRedirect(PMX_HOME_URL . '/admin.php'); // zum Login
}

function checkforgodadmin()
{
    global $prefix;
    $result = sql_query("SELECT aid FROM ${prefix}_authors where name='" . PMX_SYSADMIN_NAME . "'");
    list($the_first) = sql_fetch_row($result);
    if (empty($the_first)) {
        $first_data = mxSessionGetVar("first_data");
        mxSessionDelVar("first_data");
        mt_srand((double)microtime() * 1000000);
        $xcv = mt_rand();
        mxSessionSetVar("create_first", $xcv);
        include("header.php");
        title($GLOBALS['sitename'] . ': ' . _ADMINISTRATION);
        OpenTable();
        echo "<h4>" . _NOADMINYET . "</h4>"
         . ((isset($first_data['msg']))?'<span class="note"><b>' . $first_data['msg'] . '</b></span><br /><br />':'')
         . "<form action=\"admin.php\" method=\"post\" name=\"dofirst\">"
         . "<input type=\"hidden\" name=\"op\" value=\"create_first\" />"
         . "<input type=\"hidden\" name=\"first_check\" value=\"" . MD5($xcv) . "\" />"
         . "<table class=\"form\">"
         . "<tr><td><b>" . _NICKNAME . ":</b></td><td><input type=\"text\" name=\"first_name\" size=\"40\" maxlength=\"25\" value=\"" . ((isset($first_data['first_name']))?$first_data['first_name']:"") . "\" />  <font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
         . "<tr><td><b>" . _PASSWORD . ":</b></td><td><input type=\"password\" name=\"first_pwd\" size=\"40\" maxlength=\"20\" value=\"" . ((isset($first_data['first_pwd']))?$first_data['first_pwd']:"") . "\" />  <font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
         . "<tr><td><b>" . _EMAIL . ":</b></td><td><input type=\"text\" name=\"first_email\" size=\"40\" maxlength=\"255\" value=\"" . ((isset($first_data['first_email']))?$first_data['first_email']:$GLOBALS['adminmail']) . "\" />  <font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
         . "<tr><td><b>" . _HOMEPAGE . ":</b></td><td><input type=\"text\" name=\"first_url\" size=\"40\" maxlength=\"255\" value=\"" . ((isset($first_data['first_url']))?$first_data['first_url']:PMX_HOME_URL) . "\" /></td></tr>"
         . "<tr><td colspan=\"2\"><br />" . _CREATEUSERDATA . "  <input type=\"radio\" name=\"first_createuser\" value=\"1\" checked=\"checked\" />" . _YES . "&nbsp;&nbsp;<input type=\"radio\" name=\"first_createuser\" value=\"0\" />" . _NO . "<br /><br /><br /></td></tr>"
         . "<tr><td><b>" . _DBPASS . "</b></td><td><input type=\"password\" name=\"first_dbpass\" size=\"40\" maxlength=\"20\" value=\"" . ((isset($first_data['first_dbpass']))?$first_data['first_dbpass']:"") . "\" />  <font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
         . "<tr><td colspan=\"2\"><input type=\"submit\" value=\"" . _SUBMIT . "\" /></td></tr>"
         . "</table></form>";
        /* die Passwortfelder auf jeden Fall leeren, damit Browserdaten entfernt werden */
        pmxHeader::add_jquery();
        pmxHeader::add_script_code('$(document).ready(function(){$(\'input[type="password"]\').val("");});');
        CloseTable();
        include("footer.php");
        exit;
    }
}

function php_info()
{
    if (!mxGetAdminPref('radminsuper')) {
        mxErrorScreen('<h1>Access Denied</h1>');
        exit;
    }
    if (!empty($GLOBALS['mxDemoMode'])) {
        mxErrorScreen("<h1>" . _ERRDEMOMODE . " -> phpinfo()</h1>");
        exit;
    }
    mxSystemInfo();
    exit;
}

/**
 * admin_chmods
 *
 * @package pragmaMx
 * @author tora60
 * @copyright Copyright (c) 2011
 * @version $Id: admin.php,v 1.22.2.30.2.56 2012-03-12 23:25:19 tora60 Exp $
 * @access public
 */
class admin_chmods {
    /**
     * admin_chmods::check()
     * > http://www.pragmamx.org/doku.php?id=handbuch:installation_und_upgrade_des_systems
     *
     * @param mixed $err_dir
     * @param mixed $err_file
     * @return
     */
    public static function check(&$err_dir, &$err_file)
    {
        $dyndirs = array();
        $root = dirname(__FILE__);

        $checkfiles = array(/* zu testende Dateien */
            'config.php',
            'includes/classes/Textarea/config.inc.php',
            'includes/classes/Captcha/settings.php',
            'includes/prettyPhoto/config.php',
            'Downloads' => 'modules/Downloads/d_config.php',
            'Guestbook' => 'modules/Guestbook/include/config.inc.php',
            'My_eGallery' => 'modules/My_eGallery/settings.php',
            'UserGuest' => 'modules/UserGuest/settings.php',
            'Web_Links' => 'modules/Web_Links/l_config.php',
            'Your_Account' => 'modules/Your_Account/config.php',
            );

        foreach ($checkfiles as $modname => $value) {
            if (!is_numeric($modname) && !mxModuleActive($modname)) {
                // inaktive Module ignorieren
                continue;
            }
            if ($file = realpath(PMX_REAL_BASE_DIR . DS . $value)) {
                if (!self::_isit_writable($file)) {
                    $err_file[] = $file;
                    $dir = dirname($file);
                    if ($root != $dir) {
                        $dyndirs[] = $dir;
                    }
                }
            }
        }

        $dyndirs = array_merge($dyndirs, self::_scandir(PMX_DYNADATA_DIR, GLOB_ONLYDIR | GLOB_NOSORT));
        $dyndirs = array_merge($dyndirs, self::_scandir(PMX_MEDIA_DIR, GLOB_ONLYDIR | GLOB_NOSORT));
        $dyndirs[] = PMX_LAYOUT_DIR . DS . 'style';

        foreach ($dyndirs as $file) {
            if (!is_writable($file)) {
                $err_dir[] = $file;
            }
        }
    }

    /**
     * admin_chmods::_scandir()
     *
     * @param mixed $dir
     * @param integer $flags
     * @return
     */
    private static function _scandir($dir, $flags = 0)
    {
        $items = glob($dir . '/*', $flags);

        for ($i = 0; $i < count($items); $i++) {
            if (is_dir($items[$i])) {
                $add = glob($items[$i] . '/*', $flags);
                if ($add) {
                    $items = array_merge($items, $add);
                }
            }
        }

        return $items;
    }

    /**
     * admin_chmods::_isit_writable()
     *
     * @param mixed $filename
     * @return
     */
    private static function _isit_writable($filename)
    {
        if (!file_exists($filename)) {
            return true;
        }

        $oldmode = false;

        if (!is_writable($filename)) {
            /* aktuellen chmod der Datei zwischenspeichern */
            $oldmode = fileperms($filename);
            /* versuchen beschreibbar zu machen */
            mx_chmod($filename, PMX_CHMOD_UNLOCK);
            clearstatcache();
        }

        $result = is_writable($filename);

        if ($oldmode !== false) {
            mx_chmod($filename, $oldmode);
        }

        return $result;
    }
}

/**
 * Funktions-Switch
 */
$op = (empty($_REQUEST['op'])) ? 'adminMain' : $_REQUEST['op'];
if (MX_IS_ADMIN) {
    mxSessionDelVar('abad');
    extract(mxGetAdminSession());

    switch ($op) {
        case '':
        case 'adminMain':
        case 'login':
        case 'welcome':
            $op = 'adminMain';
            adminMain();
            break;

        case 'info':
            php_info();
            break;

        case 'mxvcheck':
            include_once(PMX_ADMIN_DIR . DS . 'modules' . DS . 'versioncheck.php');
            break;

        case 'resetBlockCache':
            include_once(PMX_SYSTEM_DIR . DS . 'mx_reset.php');
            resetBlockCache();
            mxRedirect(PMX_REFERER, _BLOCKDELCACHEOK, 1);
            break;

        case 'resetPmxCache':
            include_once(PMX_SYSTEM_DIR . DS . 'mx_reset.php');
            resetPmxCache();
            mxRedirect(PMX_REFERER, _RESETPMXCACHEOK, 1);
            break;

        case 'logoutfin':
            mxErrorScreen("<b>Admin-Logout failed</b><br />Please delete your Session-Cookie (" . MX_SESSION_NAME . ") manualy.");
            break;

        case 'logout':
            admindologout();
            break;

        default:
            $cache = load_class('Cache');
            $cache_id = 'admin_casefiles' . $aid;
            if (($casefiles = $cache->read($cache_id)) === false) {
                $casefiles = array();
                foreach ((array)glob(PMX_ADMIN_DIR . DS . 'case' . DS . 'case.*.php', GLOB_NOSORT) as $filename) {
                    if ($filename) {
                        $casefiles[] = $filename;
                    }
                }
                $cache->write($casefiles, $cache_id);
            }

            /* Ausgabepuffer aktivieren um zu pruefen ob die $op-Option vorhanden ist */
            ob_start();
            foreach ($casefiles as $filename) {
                /* Case Datei includen */
                if ($filename) {
                    include_once($filename);
                }

                /* manche Module verndern die Fehlerbehandlung */
                pmxDebug::restore();

                /* falls jetzt die header und footer.php geladen wurden, kann der Rest der */
                /* Schleife abgebrochen werden, weil die erwartende Ausgabe stattgefunden hat */
                if (defined('PMX_FOOTER') && defined('PMX_HEADER')) {
                    break;
                }
            }
            /* Falls Script hier noch nicht beendet und Ausgabepuffer leer, */
            /* stimmt was nicht, also eine Fehlermeldung zu generieren */
            $fileoutput = trim(ob_get_clean());
            if (empty($fileoutput)) {
                mxErrorScreen(sprintf(_OPNOTAVAILABLE, $op));
                exit;
            }
            echo $fileoutput;
            break;
    }
} else {
    if ($op != "create_first" && empty($_POST['first_check'])) {
        checkforgodadmin();
    }
    switch ($op) {
        case 'logoutfin':
            admindologoutfin();
            break;

        case 'login':
            mx_sys_adminlogin($_POST);
            break;

        case 'create_first':
            create_first($_POST);
            break;

        default:
            login();
    }
}

?>
