<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.8.2.1 $
 * $Author: tora60 $
 * $Date: 2012-05-04 12:37:07 $
 */

defined('mxMainFileLoaded') or die('access denied');

/* --------- Konfiguration fuer den Block ----------------------------------- */

/* Maximale Stringlaenge des Theme-Namens im Selectfeld */
$maxwordlen = 20;

/* Maximale Anzahl der Zeilen des Selectfeldes */
$maxselectlines = 6;

/* --------- Ende der Konfiguration ----------------------------------------- */

extract($block['settings'], EXTR_OVERWRITE);

$mxblockcache = false;

if (!defined('_TTCHANGEIT')) {
    mxGetLangfile('Themetest');
}

$to = basename($_SERVER['PHP_SELF']);
// index.php ist auch php_self=modules.php, deswegen hier index.php verwenden, falls $name leer ist
if ($to == 'modules.php' && empty($_REQUEST['name'])) {
    $to = './';
}

$hidden = array();
// die GET Parameter auslesen und (spter) zu einem String zusammensetzen
foreach($_GET as $key => $value) {
    $key = mxSecureValue($key, true);
    // themeselect nicht nochmals anfgen
    if ($key != 'themeselect') {
        $args[] = "{$key}={$value}";
        $hidden[] = '<input type="hidden" name="' . $key . '" value="' . $value . '" />';
    }
}

if (isset($_GET['themeselect']) && $_GET['themeselect'] != MX_THEME) {
    if (empty($_GET['themeselect'])) {
        $_GET['themeselect'] = $GLOBALS['Default_Theme'];
    }
    if (!preg_match('#[^A-Za-z0-9_-]#', $_GET['themeselect'])) {
        if (file_exists(PMX_THEMES_DIR . DS . $_GET['themeselect'] . DS . 'theme.php')) {
            if (MX_IS_USER || MX_IS_ADMIN) {
                mxSessionSetVar('theme', $_GET['themeselect']);
            } else {
                mxSetCookie('theme', $_GET['themeselect'], 1);
            }
            if (isset($args)) {
                $to .= '?' . implode('&', $args) . '';
            } else {
                $to .= '';
            }
            mxRedirect($to, '', 0);
            exit;
        }
    }
}

$themelist = mxGetAvailableThemes();
$options = array();
foreach ($themelist as $th_name => $theme) {
    $selected = ($theme == MX_THEME) ? ' selected="selected" class="current"' : '';
    $title = ($theme == $GLOBALS['Default_Theme']) ? $theme . ' (' . _TTSITEDEFAULT . ')': $theme;
    $options[$th_name] = '<option value="' . $theme . '" title="' . $title . '"' . $selected . '>' . mxCutString($theme, $maxwordlen, '..', '') . '</option>';
}
$options['#'] = '<option value="" title="' . _TTSITEDEFAULT . ' (' . $GLOBALS['Default_Theme'] . ')">-&nbsp;' . _TTSITEDEFAULT . '</option>';

ksort($options);
if (count($options) < $maxselectlines) {
    $maxselectlines = count($options);
}

/* Wenn der Block links oder rechts positioniert ist, die Breite auf fast 100% stellen */
$width = ($block['position'] == 'l' || $block['position'] == 'r') ? ' style="width: 99%;"' : '';

$content = '
<form action="' . $to . '" method="get">
' . implode("\n", $hidden) . '
<select name="themeselect" size="' . $maxselectlines . '"' . $width . '>
    ' . implode("\n    ", $options) . '
</select>
<input type="submit" value="' . _TTCHANGEIT . '" />
</form>
';

?>