<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.33.4.13 $
 * $Author: tora60 $
 * $Date: 2012-05-04 14:51:06 $
 */

/* Nur Parsefehler melden */
error_reporting(E_PARSE);

/**
 * Ausgabepuffer auf jeden Fall starten, wird am Ende dieser Datei
 * wieder gelöscht und evtl. der ob_gzhandler gestartet
 */
ob_start();

/* zu alte php-Version */
(version_compare(PHP_VERSION, '5.2.0', '>=')) or die('Sorry, PHP-Version >= 5.2.0 is required for pragmaMx.');

/* Direktaufruf verhindern */
(stripos($_SERVER['PHP_SELF'], basename(__FILE__)) === false) or die('access denied');

/* Versionsinformation */
define('PMX_VERSION', '1.12.2');
define('MX_VERSION', 'pragmaMx ' . PMX_VERSION); // deprecated
preg_match('#v ([0-9\.]{2,})\s([0-9]{4})[-/]([0-9]{1,2})[-/]([0-9]{1,2})#', '$Id: mainfile.php,v 1.33.4.13 2012-05-04 14:51:06 tora60 Exp $', $key);
define('PMX_VERSION_NUM', PMX_VERSION . ".$key[1]");
define('PMX_VERSION_DATE', "$key[2]-$key[3]-$key[4]");
define('PMX_VERSION_SUB', "$key[1]/$key[2]-$key[3]-$key[4]"); // deprecated
/* Versionsinformation Ende */

$keysToSkip = array('GLOBALS', '_SERVER', '_GET', '_POST', '_FILES', '_COOKIE', '_SESSION', '_REQUEST', '_ENV', 'PHP_SELF', 'keysToSkip', 'php_errormsg', 'HTTP_RAW_POST_DATA', 'http_response_header', 'argc', 'argv');
foreach ($_REQUEST as $key => $value) {
    /* pruefen ob gueltiger Schluessel, ansonsten komplett entfernen */
    if (preg_match('#[^a-zA-Z0-9-_\x7f-\xff]#', $key)) {
        unset($_REQUEST[$key], $_COOKIE[$key], $_GET[$key], $_POST[$key]);
        continue;
    }
    /* killt Variablen, die bei register_globals=ON uebergeben werden koennten */
    if (in_array($key, $keysToSkip)) {
        die('unaccepted requestkey: ' . $key);
    }
    unset($$key);
}
unset($key, $value, $keysToSkip);

/* falls die Datei bereits includet wurde, abbrechen */
if (defined('PMX')) {
    return;
}

/* ich bin da... */
define('PMX', true);
define('mxMainFileLoaded', true);

/* Benchmarkanzeige initialisieren */
if (!defined('MX_TIME')) {
    define('MX_TIME', microtime(true));
}

/* Kurzform dieser System-Konstanten erstellen */
define('DS', DIRECTORY_SEPARATOR);

/* der wichtigste Pfad: zum mx-Root, ohne Slash am Ende */
define('PMX_REAL_BASE_DIR', dirname(__FILE__));

/* Ordner mit den Systemdateien, weitere Ordner werden in der mx_baseconfig definiert */
define('PMX_SYSTEM_DIR', PMX_REAL_BASE_DIR . DS . 'includes');

/* Ordner mit den Administrationsdateien */
define('PMX_ADMIN_DIR', PMX_REAL_BASE_DIR . DS . 'admin');

/* Ordner mit dynamischen Inhalten (Logdatein, Cache, etc.) */
define('PMX_DYNADATA_DIR', PMX_REAL_BASE_DIR . DS . 'dynadata');

/* Ordner mit dynamischen Medien (Bilder, Dokumente, etc.) */
define('PMX_MEDIA_DIR', PMX_REAL_BASE_DIR . DS . 'media');

/* Ordner mit den Systemdateien fuer die HTML-Ausgabe (view) */
define('PMX_LAYOUT_DIR', PMX_REAL_BASE_DIR . DS . 'layout');

/* Ordner mit den Modulen */
define('PMX_MODULES_DIR', PMX_REAL_BASE_DIR . DS . 'modules');

/* Ordner mit den System-Bloecken */
define('PMX_BLOCKS_DIR', PMX_REAL_BASE_DIR . DS . 'blocks');

/* Ordner mit den Themes */
define('PMX_THEMES_DIR', PMX_REAL_BASE_DIR . DS . 'themes');

/* Ordner mit den Bildchen */
define('PMX_IMAGE_DIR', PMX_REAL_BASE_DIR . DS . 'images');

/* Ordner mit den Systemsprachen */
define('PMX_LANGUAGE_DIR', PMX_REAL_BASE_DIR . DS . 'language');

/* Ordner mit den Themes */
define('PMX_SETUP_DIR', PMX_REAL_BASE_DIR . DS . 'setup');

/* Ordner mit Standard Javascripten */
define('PMX_JAVASCRIPT_DIR', PMX_SYSTEM_DIR . DS . 'javascript');

/* die Systemkonfigurationsdatei */
define('PMX_CONFIGFILE' , PMX_REAL_BASE_DIR . DS . 'config.php');

/* Parsefehler in config.php abfangen und bei Bedarf Setup anbieten. */
if (!@include(PMX_CONFIGFILE)) {
    $msg = '<img src="http://www.pragmamx.org/images/logo.gif" alt="pragmaMx-Error" /><ul>';
    if (@file_exists('setup') && !is_file(PMX_CONFIGFILE)) {
        $msg .= '
		<li>pragmaMx seems not to be installed correctly, or you\'re running pragmaMx for the first time. Click <a href="setup/" rel="nofollow"><b>here</b></a> to run the installer.</li>
		<li>pragmaMx scheint nicht korrekt installiert zu sein oder Sie starten pragmaMx zum erstem Mal. Klicken Sie <a href="setup/" rel="nofollow"><b>hier</b></a>, um den Installer zu starten.</li>
		<li>pragmaMx semble ne pas &ecirc;tre install&eacute; correctement, ou vous ex&eacute;cutez pragmaMx pour la premi&egrave;re fois. Cliquer <a href="setup/" rel="nofollow"><b>ici</b></a> pour commencer l\'installation.</li>
		<li>pragmaMx düzgün kurulmam&#305;&#351; veya ilk defa pragmaMx &#231;al&#305;&#351;t&#305;r&#305;yorsunuz. Kurulumu ba&#351;latmak i&#231;in <a href="setup/" rel="nofollow"><b>buraya</b></a> t&#305;klay&#305;n&#305;z.</li>
		';
    } else {
        $msg .= '
		<li>The config-file is missing or corrupted!</li>
		<li>Die Konfigurationsdatei fehlt oder ist besch&auml;digt!</li>
		<li>Le fichier config.php est absent ou corrompu!</li>
		<li>Ayar dosyas&#305; eksik veya hatal&#305;!</li>
		';
    }
    $msg .= '</ul>';
    die($msg);
}

ini_set('gpc_order', 'GPCS'); // ohne Environment, kann ueber getenv() abgefragt werden
ini_set('magic_quotes_runtime', '0');
ini_set('magic_quotes_sybase', '0');

/* Länderspezifische Einstellungen, wird teilweise durch die Einstellung der Sprachdateien überschrieben */
setlocale(LC_ALL, array('en_GB.ISO-8859-15', 'en_GB', 'en_US', 'en', 'eng', 'english-uk', 'english-us', 'uk', 'us', 'GB', 'GBR', '826', 'CTRY_UNITED_KINGDOM', '840', 'CTRY_UNITED_STATES'));

/* Standardzeitzone, die von allen Zeitfunktionen verwendet wird, einstellen  */
date_default_timezone_set($default_timezone);

/**
 * Alle Fehler ausser E_NOTICE melden,
 * dies ist die Standardeinstellung in php.ini
 */
error_reporting(E_ALL ^ E_NOTICE);

/* System-Funktionen laden und API's einbinden */
require_once(PMX_SYSTEM_DIR . DS . 'mx_system.php');
require_once(PMX_SYSTEM_DIR . DS . 'mx_api.php');
require_once(PMX_SYSTEM_DIR . DS . 'mx_api_2.php');

/* nur wenn die mod.php aufgerufen wurde ist die Funktion aus der mx_modrewrite.php */
/* hier bereits vorhanden, dann die uebergabeparameter aus der mod.php behandeln. */
if (defined('PMXMODREWRITE')) {
    load_class('Modrewrite', false);
    pmxModrewrite::undo();
}

/* Systemkonstanten definieren, diese Datei kann in gewissem Masse angepasst werden */
require_once(PMX_SYSTEM_DIR . DS . 'mx_baseconfig.php');

/* Fehlerbehandlung und Debugmethoden aktivieren */
load_class('Debug', false);
pmxDebug::init();

/* Datenbankverbindung herstellen */
require_once(PMX_SYSTEM_DIR . DS . 'sql_layer.php');
$dbi = sql_connect($dbhost, $dbuname, $dbpass);
if (empty($dbi)) {
    die('Selection from database failed - please check the settings!');
}

/* auf aktuelle MySQL-Version pruefen */
if (version_compare(MX_SQL_VERSION, '4.0.18', '<')) {
    die('Sorry, MySQL-Version >= 4.0.18 is required for pragmaMx.');
}

/* Session starten */
require_once(PMX_SYSTEM_DIR . DS . 'mx_session.php');
if (!mxSessionStart()) {
    die('Session: initialisation failed');
}

/* letzte URL abfragen, diese wird nur in der header.php aktualisiert */
define('PMX_REFERER', mxSessionGetVar('lasturl'));

/* Detection System starten */
if ($vkpSafeSqlinject) {
    require_once(PMX_SYSTEM_DIR . DS . 'mx_detect.php');
    pmxDetect::check_banning();
    pmxDetect::start();
}

/* Userberechtigungen */
pmxUserStored::init();

/* Fehlerbehandlung und Debugmethoden aktivieren */
pmxDebug::start();

load_class('Header', false);

/**
 * restrictor von http://www.bot-trap.de/
 */
if (@file_exists(PMX_REAL_BASE_DIR . DS . 'restrictor' . DS . 'bridge.php')) {
    @include_once(PMX_REAL_BASE_DIR . DS . 'restrictor' . DS . 'bridge.php');
}

/**
 * Demomode bei berechtigten Admins wieder abschalten
 */
$mxDemoMode = mxDemoMode();

/**
 * Superglobals zwischenspeichern, fuer Module, die eine eigene Behandlung
 * der Superglobals vorsehen
 */
$_MX_UNCLEAN_GET = $_GET;
$_MX_UNCLEAN_POST = $_POST;
$_MX_UNCLEAN_COOKIE = $_COOKIE;
$_MX_UNCLEAN_FILES = $_FILES;
$_MX_UNCLEAN_SERVER = $_SERVER;

/**
 * - simuliert magic_quotes_gpc=1
 * - ersetzt bestimmte Sonderzeichen durch ihren HTML-Code
 */
$_GET = mxSecureValue($_GET, true);
$_POST = mxSecureValue($_POST, false);
$_COOKIE = mxSecureValue($_COOKIE, true);
$_SERVER = mxSecureValue($_SERVER, true); // $_GET in query_string etc.

if (!$mxDemoMode && count($_FILES) && !empty($_FILES)) {
    foreach ($_FILES as $upfile => $upfile_data) {
        if (is_array($upfile_data['name'])) {
            foreach ($upfile_data['name'] as $key => $upfile_name) {
                $upfile_name = mxSecureValue($upfile_name, true); // (das gleiche wie $upfile_data['name'][$key])
                ${$upfile}[$key] = $upfile_data['tmp_name'][$key];
                ${$upfile.'_name'}[$key] = $upfile_name;
                ${$upfile.'_type'}[$key] = $upfile_data['type'][$key];
                ${$upfile.'_size'}[$key] = $upfile_data['size'][$key];
                $_FILES[$upfile]['name'][$key] = $upfile_name;
            }
        } else {
            $upfile_name = mxSecureValue($upfile_data['name'], true);
            $$upfile = $upfile_data['tmp_name'];
            ${$upfile.'_name'} = $upfile_name;
            ${$upfile.'_type'} = $upfile_data['type'];
            ${$upfile.'_size'} = $upfile_data['size'];
            $_FILES[$upfile]['name'] = $upfile_name;
        }
    }
    unset($upfile, $upfile_name, $upfile_data);
}
/* fileupload im Demomode verhindern */
if ($mxDemoMode || (count($_FILES) > 0 && empty($_FILES))) {
    $_FILES = array();
}

/* Speicher aufraeumen */
unset($key);
if (!$mxSiteService) {
    unset($mxSiteServiceText);
}
if (MX_IS_USER) {
    mxSessionDelVar('vkpnewuser');
}

/**
 * Request-Variablen zur Kompatibilitaet neu erstellen
 */
$HTTP_GET_VARS = &$_GET;
$HTTP_POST_VARS = &$_POST;
$HTTP_COOKIE_VARS = &$_COOKIE;
$HTTP_POST_FILES = &$_FILES;
// Servervariablen zur Kompatibilitaet neu erstellen
$HTTP_SERVER_VARS = &$_SERVER;
// neue globale Request-Variablen erstellen
$_REQUEST = array_merge($_GET, $_POST); /// ohne Cookie, weil unnoetig
// die jetzt fertig behandelten Request-Variablen in den globalen Scope schreiben
extract($_REQUEST, EXTR_SKIP);

/* neue globale Server-Variablen erstellen, falls register_globals aus */
if (!mxIniGet('register_globals')) {
    extract($_SERVER, EXTR_OVERWRITE);
}
/**
 * ENDE ... simuliert magic_quotes_gpc=1...
 */

/**
 * 4nc
 */
if (isset($ko) && $ko == 1 && (isset($table) || isset($f) || isset($datei) || isset($ok))) {
    unset($ko, $_REQUEST['ko'], $_POST['ko'], $_GET['ko'], $f, $ok, $table, $datei);
    mxSecureLog('Hack-Attack', '4n-Community-hack', 'with_request');
    $mxDemoMode = 1;
}

/* Sprache einstellen */
$arr_lang = array();
if (isset($_REQUEST['newlang'])) {
    $arr_lang['request'] = preg_replace('#[^a-zA-Z0-9_]#', '_', $_REQUEST['newlang']);
}
$arr_lang['session'] = mxSessionGetVar('lang');
if (MX_IS_USER) {
    $uinf = pmxUserStored::current_userdata();
    $arr_lang['userdata'] = $uinf['user_lang'];
}

$arr_lang['config'] = $language;
$arr_lang = array_merge($arr_lang, $language_avalaible);
$arr_lang = array_intersect($arr_lang, $language_avalaible);
$arr_lang = array_unique($arr_lang);
foreach ($arr_lang as $key => $currentlang) {
    if ($currentlang && file_exists(PMX_LANGUAGE_DIR . DS . 'lang-' . $currentlang . '.php')) {
        if ($key === 'request') {
            mxSessionSetVar('lang', $currentlang);
        }
        break;
    }
}
mxGetLangfile();

setlocale(LC_TIME, _SETLOCALE);
setlocale(LC_COLLATE, _SETLOCALE);
setlocale(LC_MONETARY, _SETLOCALE);

/* Theme definieren */
define('MX_THEME', mxGetTheme());
define('MX_THEME_DIR', 'themes/' . MX_THEME);

/* Website Tracking aktualisieren */
if (@$vkpTracking) {
    include_once(PMX_SYSTEM_DIR . DS . 'trackhack.php');
}

/* nur fuer phpNuke-Kompatibilitaet */
if (!$mxDeactNukeCompatible) {
    include_once(PMX_SYSTEM_DIR . DS . 'nukefunctions.php');
}

/* Referer aktualisieren */
mxReferer();

/* Bannfunktion ausfuehren */
vkpIpBanning();

/**
 * output-handling
 * falls bereits ausgaben erfolgt, diese zwischenspeichern und Puffer beenden
 */
$obtemp = trim(@ob_get_clean());

/* Pufferhandler ermitteln */
$mxoutputhandler = mxGetOutputHandler();

/* Ausgabepuffer starten und evtl. Ausgabe komprimieren */
ob_implicit_flush(0);
if ($mxoutputhandler) {
    ob_start($mxoutputhandler);
}
unset($mxoutputhandler);

/*
 * Ausgabepuffer auf jeden Fall ein 2tes mal starten, dass bei Fehlern, die Ausgabe,
 * auch erst am Ende des scripts in den komprimierten Handler geschrieben werden
 * dies verhindert fruehzeitiges senden von HTTP-Headern (session)
 */
ob_start();

/* evtl. bereits vorhandene zwischengespeicherte Ausgaben jetzt erst ausgeben */
if (!empty($obtemp)) {
    echo $obtemp;
}
unset($obtemp);

/**
 * hier kann die Systemkonfiguration ueberprueft werden
 * einfach folgende Zeile einkommentieren
 */
// mxSystemInfo();
// mxDebugFuncVars($GLOBALS);
?>