<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.59.2.1 $
 * $Author: tora60 $
 * $Date: 2012-03-12 23:27:29 $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!defined('mxYALoaded')) define('mxYALoaded', 1);
$module_name = basename(dirname(__FILE__));

$url_images = "images";

if (MX_IS_USER) {
    mxRedirect(PMX_HOME_URL . "/modules.php?name=Your_Account");
    die();
}

mxGetLangfile("Your_Account");
require_once(PMX_SYSTEM_DIR . DS . "mx_userfunctions.php");

$pagetitle = _REGNEWUSER;

function new_user($msg = '')
{
    global $prefix, $module_name;
    $userconfig = load_class('Userconfig');
    $oldvals = array();
    mt_srand((double)microtime() * 1000000);
    mxSessionSetVar("newusercheck", mt_rand());
    if (is_array(mxSessionGetVar("vkpnewuser"))) {
        $oldvals = mxSessionGetVar("vkpnewuser");
        mxSessionDelVar("vkpnewuser");
        $oldvals = mxStripSlashes($oldvals);
        /* alle Werte in das richtige Format bringen */
        $oldvals = prepareUserdataFromRequest($oldvals);
        $oldvals['user_bday'] = (empty($oldvals['birthday'])) ? '' : strftime('%Y-%m-%d', $oldvals['birthday']);
    }

    include('header.php');
    title(_USERREGLOGIN);

    userNavigation('register');
    echo '<div class="tabs-panel">';
    echo "<p>" . _ASREGUSER . "</p>\n"
     . "<ul>\n"
     . "<li>" . _ASREG1 . "</li>\n"
     . "<li>" . _ASREG2 . "</li>\n"
     . "<li>" . _ASREG3 . "</li>\n"
     . "<li>" . _ASREG4 . "</li>\n"
     . "<li>" . _ASREG5 . "</li>\n"
     . "<li>" . _ASREG6 . "</li>\n"
     . "<li>" . _ASREG7 . "</li>\n"
     . "</ul>\n"
     . "<p>" . _REGISTERNOW . "<br />\n"
     . _WEDONTGIVE . "</p>\n";
    if ($userconfig->yaproofdate) {
        echo '<p>' . sprintf(_ERRAPPROVEDATE, $userconfig->yaproofdate) . '</p>';
    }
    echo "<p>" . _COOKIEWARNING . "</p><br />\n";

    if ($msg) {
        openTableAl();
        echo '<h3 style="text-align: center;">' . $msg . '</h3>';
        closeTableAl();
        echo '<br />';
    }

    echo "<form name=\"Register\" action=\"modules.php?name=" . $module_name . "\" method=\"post\">\n"
     . "<table cellspacing=\"1\" cellpadding=\"3\" class=\"bgcolor1\">"
     . "<tr valign=\"top\"><th colspan=\"4\" class=\"bgcolor2 bigger\">" . _YA_ACCOUNTDATA . "</th></tr>"
     . "<tr valign=\"top\"><td width=\"20%\" class=\"bgcolor2\"><b>" . _NICKNAME . ":</b></td><td colspan=\"3\" class=\"bgcolor3\">\n"
     . "<input type=\"text\" name=\"uname\" size=\"50\" maxlength=\"25\" value=\"" . ((isset($oldvals['uname'])) ? mxentityquotes($oldvals['uname']) : "") . "\" />&nbsp;&nbsp;<font class=\"tiny\">" . _REQUIRED . "</font></td></tr>\n";
    echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _UREALEMAIL . ":</b></td><td colspan=\"3\" class=\"bgcolor3\">\n"
     . "<input type=\"text\" name=\"email\" size=\"50\" maxlength=\"100\" value=\"" . ((isset($oldvals['email'])) ? mxentityquotes($oldvals['email']) : "") . "\" />&nbsp;&nbsp;<font class=\"tiny\">" . _REQUIRED . "</font><br /><span class=\"tiny\">" . _EMAILNOTPUBLIC . "</span></td></tr>\n";

    switch ($userconfig->register_option) {
        case 1:
        case 3:
        case 4:
            /* die Passwortfelder auf jeden Fall leeren, damit Browserdaten entfernt werden */
            pmxHeader::add_jquery();
            pmxHeader::add_script_code('$(document).ready(function(){$(\'input[type="password"]\').val("");});');
            $xpass = makepass();
            $msg = _PASSWILLSEND;
            echo "<tr valign=\"top\"><td class=\"bgcolor2\">
            <b>" . _DESIREDPASS . ":</b>
            <input type=\"hidden\" name=\"xpass\" value=\"" . $xpass . "\" />
            </td><td colspan=\"3\" class=\"bgcolor3\">\n
            <input type=\"password\" name=\"pass\" size=\"22\" maxlength=\"20\" value=\"\" />&nbsp;
            <input type=\"password\" name=\"vpass\" size=\"22\" maxlength=\"20\" value=\"\" />&nbsp; " . sprintf(_OPTIONAL1, $userconfig->minpass) . "\n<br />
            <span class=\"tiny\">" . _OPTIONAL2 . " " . _YA_PWVORSCHLAG . ":&nbsp;" . $xpass . "</span>
            </td></tr>\n";
            break;
        case 2:
            $msg = _YA_REG_MAILMSG2;
            break;
    }

    echo vkpUserform($oldvals);
    /**
     * START Benutzer muessen den AGB zustimmen - 2005-18-05  (RtR)
     */
    if ($userconfig->agb_content) {
        echo "<tr valign=\"top\"><td width=\"20%\" class=\"bgcolor2\"><strong>" . _EULA . ":</strong></td><td colspan=\"3\" class=\"bgcolor3\">\n";
        switch ($userconfig->agb_content) {
            case "1":
                $agb_out = $userconfig->agb_content_sub1;
                $moduleslist = sql_query("SELECT DISTINCT artid FROM " . $prefix . "_seccont WHERE artid='$agb_out'");
                list($linkartid) = sql_fetch_row($moduleslist);
                if (!empty($linkartid)) {
                    $linkout = "modules.php?name=Sections&amp;op=viewarticle&amp;artid=$linkartid";
                } else {
                    $linkout = "#>";
                }
                break;
            case "2":
                $agb_out = $userconfig->agb_content_sub2;
                $moduleslist = sql_query("SELECT DISTINCT pid FROM " . $prefix . "_pages WHERE pid='$agb_out'");
                list($linkpid) = sql_fetch_row($moduleslist);
                if (!empty($linkpid)) {
                    $linkout = "modules.php?name=Content&amp;pid=$linkpid";
                } else {
                    $linkout = "#>";
                }
                break;
            case "3":
                $agb_out = $userconfig->agb_content_sub3;
                $moduleslist = sql_query("SELECT DISTINCT title FROM " . $prefix . "_modules WHERE mid='$agb_out'");
                list($linktitle) = sql_fetch_row($moduleslist);
                if (!empty($linktitle)) {
                    $linkout = "modules.php?name=$linktitle";
                } else {
                    $linkout = "#>";
                }
                break;
            default:
                $linkout = "#>";
        }
        echo "<input type=\"checkbox\" name=\"readrules\" value=\"1\" /> " . _IHAVE . " <a href=\"{$linkout}\" target=\"_blank\" title=\"" . _EULA . " " . _SHOWIT . "\"><strong>" . _EULA . "</strong></a> " . _READDONE . " " . _REQUIRED . "</font></td></tr>\n";
    }
    /**
     * ENDE Benutzer muessen den AGB zustimmen
     */
    echo "<tr class=\"bgcolor2\"><td>\n<input type=\"submit\" value=\"" . _NEWUSER . "\" />&nbsp;&nbsp;";
    echo "</td>"
     . "<td colspan=\"3\">" . $msg . "\n"
     . "<input type=\"hidden\" name=\"op\" value=\"confirm\" />\n"
     . "<input type=\"hidden\" name=\"name\" value=\"" . $GLOBALS['module_name'] . "\" />\n"
     . "<input type=\"hidden\" name=\"check\" value=\"" . md5(mxsessiongetvar("newusercheck")) . "\" />\n"
     . "</td></tr></table>\n"
     . "</form>";
    echo '</div>'; // tabs-panel
    include('footer.php');
}

function confirmNewUser($pvs, $msg = '')
{
    global $module_name;
    $userconfig = load_class('Userconfig');
    $stop = '';

    $pvs['user_sexus'] = (empty($pvs['user_sexus'])) ? 0 : (int)$pvs['user_sexus'];
    foreach($pvs as $key => $value) {
        if ($key != "pass" && $key != "vpass" && $key != "xpass" && $key != "check") { // Passworte und check ausnehmen
            $value = mxPrepareCensored($value); // bad-words ausfiltern
        }
        $session[$key] = $value; // Variablen fuer session erstellen ohne stripslashes
        $pvs[$key] = mxStripSlashes($value); // Variablen fuer Anzeige erstellen mit stripslashes
    }

    $check = (empty($pvs['check'])) ? mt_rand() : $pvs['check']; // sicherstellen, dass $check initialisiert ist
    if ($check != MD5(mxSessionGetVar("newusercheck"))) {
        pmxDebug::pause();
        mxSecureLog("SecLog", "Bad Usercreation - Account: " . $pvs['uname'] . " (no session-check-id)");
        session_write_close();
        mxRedirect(PMX_HOME_URL . "/modules.php?name=" . $GLOBALS['module_name'] . "&op=new_user");
        die();
    }

    switch ($userconfig->register_option) {
        case 1:
        case 3:
        case 4:
            if (empty($pvs['pass']) || empty($pvs['vpass'])) {
                $pvs['pass'] = $pvs['xpass'];
                $pvs['vpass'] = $pvs['xpass'];
            } else if ($pvs['pass'] != $pvs['vpass']) {
                $stop = _NOTCONFIRMED;
            } else if ((strlen($pvs['pass']) < $userconfig->minpass) || (strlen($pvs['vpass']) < $userconfig->minpass)) {
                $stop = _YOUPASSMUSTBE . " <b>" . $userconfig->minpass . "</b> " . _CHARLONG;
            }
            $session['mailpass'] = $pvs['pass'];
            $session['setpass'] = md5($pvs['pass']);
            break;
        case 2:
            $xpass = makepass();
            $session['mailpass'] = $xpass;
            $session['setpass'] = md5($xpass);
            break;
        default:
            $session['mailpass'] = makepass();
            $session['setpass'] = md5($session['mailpass']);
            break;
    }

    mxSessionSetVar("vkpnewuser", $session); // praeparierte Postvars in Session stellen

    if ($stop) {
        $pvs = $stop;
    } else {
        $pvs = userCheck($pvs);
    }

    if (!is_array($pvs)) {
        // $pvs enthlt hier die Fehlermeldung
        return new_user($pvs);
    }

    if ($pvs['birthday']) {
        $pvs['cbday'] = mx_strftime(_SHORTDATESTRING, $pvs['birthday']);
    }

    include('header.php');
    title(_USERREGLOGIN);
    userNavigation('register');
    echo '<div class="tabs-panel">';
    echo "<form action=\"modules.php?name=" . $module_name . "\" method=\"post\"><br />\n";
    echo '<p class="bigger">' . _HELLO . ' <b>' . $pvs['uname'] . '</b>,</p><p>' . _USERCHECKDATA . '</p>';
    if ($msg) {
        openTableAl();
        echo '<h3 style="text-align: center;">' . $msg . '</h3>';
        closeTableAl();
        echo '<br />';
    }
    echo "<table cellspacing=\"1\" cellpadding=\"3\" class=\"bgcolor1\">\n";
    echo "<tr valign=\"top\"><td width=\"20%\" class=\"bgcolor2\"><b>" . _NICKNAME . ":</b></td><td class=\"bgcolor3\"><b>" . $pvs['uname'] . "</b></td></tr>\n";
    if ($userconfig->register_option === 1 || $userconfig->register_option === 3 || $userconfig->register_option === 4) {
        echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _PASSWORD . ":</b></td><td class=\"bgcolor3\"><b><a href=\"#\" onclick=\"alert('" . $pvs['vpass'] . "'); return false;\">" . _YA_CLICKTOSHOW . "</a></b></td></tr>\n";
    }
    if (!empty($pvs['email'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _UREALEMAIL . ":</b></td><td class=\"bgcolor3\"><b>" . $pvs['email'] . "</b></td></tr>\n";
    if (function_exists("confirmNewUser_option")) {
        confirmNewUser_option($pvs);
    } else {
        if (!empty($pvs['realname'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _UREALNAME . ":</b></td><td class=\"bgcolor3\">" . $pvs['realname'] . "</td></tr>\n";
        if (!empty($pvs['user_sexus'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _YA_USEXUS . ":</b></td><td class=\"bgcolor3\">" . vkpGetSexusString($pvs['user_sexus']) . "</td></tr>\n";
        if (!empty($pvs['cbday'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _YA_UBDAY . ":</b></td><td class=\"bgcolor3\">" . $pvs['cbday'] . "</td></tr>\n";
        if (!empty($pvs['url'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _YOURHOMEPAGE . ":</b></td><td class=\"bgcolor3\">" . $pvs['url'] . "</td></tr>\n";
        if (!empty($pvs['user_icq'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _YICQ . ":</b></td><td class=\"bgcolor3\">" . $pvs['user_icq'] . "</td></tr>\n";
        if (!empty($pvs['user_aim'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _YAIM . "</b></td><td class=\"bgcolor3\">" . $pvs['user_aim'] . "</td></tr>\n";
        if (!empty($pvs['user_yim'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _YYIM . ":</b></td><td class=\"bgcolor3\">" . $pvs['user_yim'] . "</td></tr>\n";
        if (!empty($pvs['user_msnm'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _YMSNM . ":</b></td><td class=\"bgcolor3\">" . $pvs['user_msnm'] . "</td></tr>\n";
        if (!empty($pvs['user_from'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _YLOCATION . ":</b></td><td class=\"bgcolor3\">" . $pvs['user_from'] . "</td></tr>\n";
        if (!empty($pvs['user_occ'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _YOCCUPATION . ":</b></td><td class=\"bgcolor3\">" . $pvs['user_occ'] . "</td></tr>\n";
        if (!empty($pvs['user_intrest'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _YINTERESTS . ":</b></td><td class=\"bgcolor3\">" . $pvs['user_intrest'] . "</td></tr>\n";
        if (!empty($pvs['bio'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _EXTRAINFO . ":</b></td><td class=\"bgcolor3\">" . $pvs['bio'] . "</td></tr>\n";
        if (!empty($pvs['user_sig'])) echo "<tr valign=\"top\"><td class=\"bgcolor2\"><b>" . _SIGNATURE . ":</b></td><td class=\"bgcolor3\">" . $pvs['user_sig'] . "</td></tr>\n";
    }
    echo "</table>";

    $captcha_object = load_class('Captcha', 'registrationon');
    echo '<br />' . $captcha_object->complete();

    echo "<input type=\"hidden\" name=\"name\" value=\"" . $GLOBALS['module_name'] . "\" />\n";
    echo "<input type=\"hidden\" name=\"op\" value=\"finish\" />\n";
    echo "&nbsp;&nbsp;<input type=\"submit\" value=\"" . _FINISH . "\" /> &nbsp;&nbsp;<a href=\"modules.php?name=" . $module_name . "\">" . strip_tags(_GOBACK) . "</a>";
    if (($userconfig->register_option === 1 || $userconfig->register_option === 3 || $userconfig->register_option === 4) && empty($pvs['pass'])) {
        echo "<p class=\"tiny\">" . _NOTPROVIDE . "</p>";
    }
    echo "</form>";
    echo '</div>'; // tabs-panel
    include('footer.php');
}

function finishNewUser()
{
    global $user_prefix, $prefix, $module_name;

    $session = mxSessionGetVar("vkpnewuser"); // die Sessiondaten sind hier noch mit Slashes!
    $userconfig = load_class('Userconfig');

    $captcha_object = load_class('Captcha', 'registrationon');

    if (!$captcha_object->check($_POST, 'captcha')) {
        confirmNewUser($session, _CAPTCHAWRONG);
        exit;
    }

    $newusercheck = mxSessionGetVar("newusercheck");
    mxSessionDelVar("newusercheck");
    $check = (empty($session["check"])) ? mt_rand() : $session["check"]; // sicherstellen, dass $check initialisiert ist
    if ($check != MD5($newusercheck)) {
        mxSecureLog("SecLog", "Bad Usercreation - (no session-check-id)");
        session_write_close();
        mxRedirect(PMX_HOME_URL . "/modules.php?name=" . $GLOBALS['module_name'] . "&op=new_user");
        die();
    }
    $session = userCheck($session);

    if (!is_array($session)) {
        return new_user($session);
    }
    // // verschiedene Feldwerte mit Grundwerten belegen, bzw. auf Gueltigkeit ueberpruefen
    $setbday = (empty($session['birthday'])) ? "NULL" : "'" . strftime('%Y-%m-%d', $session['birthday']) . "'";
    $userip = MX_REMOTE_ADDR;
    $user_regtime = time();
    $user_regdate = mxGetNukeUserregdate();
    $user_ingroup = $userconfig->default_group;

    switch ($userconfig->register_option) {
        case 0:
            // generiertes Passwort zusenden
            $user_stat = 1;
            $msg1 = _YOUAREREGISTERED_0;
            $msg3 = "<a href=\"modules.php?name=Your_Account\">" . _LOGIN . "</a>";
            break;
        case 1:
            // eigenes Passwort sofort freischalten
            $user_stat = 1;
            $msg1 = _YOUAREREGISTERED_1;
            $msg3 = "<form action=\"modules.php?name=" . $module_name . "\" method=\"post\">\n
        <input type=\"hidden\" name=\"uname\" value=\"" . $session['uname'] . "\" />\n
        <input type=\"hidden\" name=\"pass\" value=\"" . $session['mailpass'] . "\" />\n
        " . (mxGetUserLoginCheckField()) . "
        <input type=\"submit\" value=\"" . _DIRECTLOGIN . "\" />\n
        </form>\n";
            break;
        case 2:
            // generiertes Passwort zusenden, Adminfreischaltung
            mt_srand((double)microtime() * 1000000);
            $user_stat = 0;
            $setpass = md5(mt_rand()); /// ungueltiges Passwort schreiben
            $msg1 = _YOUAREREGISTERED_2;
            $msg3 = "<br /><br /><a href=\"./\">" . _HOME . "</a>";
            break;
        case 3:
        case 4:
            // eigenes Passwort, Aktivierungslink zusenden
            $user_stat = 0;
            $msg1 = _YOUAREREGISTERED_3;
            $msg3 = "<br /><br /><a href=\"./\">" . _HOME . "</a>";
            break;
    }

    $sqlvars = mxAddSlashesForSQL($session);

    extract($sqlvars);

    if (isset($uname)) $fields[0] = "uname = '$uname'";
    if (isset($setpass)) $fields[1] = "pass = '$setpass'";
    if (isset($email)) $fields[2] = "email = '$email'";
    if (isset($realname)) $fields[3] = "name = '$realname'";
    if (isset($url)) $fields[5] = "url = '" . mx_urltohtml($url) . "'";
    if (isset($user_regdate)) $fields[7] = "user_regdate = '$user_regdate'";
    if (isset($user_icq)) $fields[8] = "user_icq = '$user_icq'";
    if (isset($user_occ)) $fields[9] = "user_occ = '$user_occ'";
    if (isset($user_from)) $fields[10] = "user_from = '$user_from'";
    if (isset($user_intrest)) $fields[11] = "user_intrest = '$user_intrest'";
    if (isset($user_sig)) $fields[12] = "user_sig = '$user_sig'";
    if (isset($user_aim)) $fields[13] = "user_aim = '$user_aim'";
    if (isset($user_yim)) $fields[14] = "user_yim = '$user_yim'";
    if (isset($user_msnm)) $fields[15] = "user_msnm = '$user_msnm'";
    $fields[16] = "user_level = 1";
    if (isset($user_ingroup)) $fields[18] = "user_ingroup = $user_ingroup";
    if (isset($user_regtime)) $fields[19] = "user_regtime = $user_regtime";
    if (isset($user_stat)) $fields[20] = "user_stat = $user_stat";
    if (isset($user_sexus)) $fields[21] = "user_sexus = $user_sexus";
    if (isset($user_regtime)) $fields[22] = "user_lastvisit = $user_regtime";
    if (isset($userip)) $fields[23] = "user_lastip = '$userip'";
    if (isset($setbday)) $fields[24] = "user_bday = $setbday"; // ohne anfuehrz.
    if (isset($bio)) $fields[25] = "bio = '$bio'";
    // if (isset($uname))        $fields[25] = "user_viewemail = $user_viewemail";
    if (function_exists("finishNewUser_option")) {
        // loeschen oder hinzufuegen von Insert-Elementen
        $fields = finishNewUser_option($session, $fields);
    }

    switch ($userconfig->register_option) {
        case 3:
        case 4:
            mxCheckUserTempTable(); // temporre Tabelle auf kompatibilitt pruefen und ggf. anpassen
            srand ((double)microtime() * 1000000);
            $check_key = rand(0, 32767);
            $check_time = time();
            $check_ip = MX_REMOTE_ADDR;
            $sendpass = base64_encode($session['mailpass']);
            $check_host = gethostbyaddr($userip);
            $fields[] = "check_key = $check_key";
            $fields[] = "check_time = $check_time";
            $fields[] = "check_ip = '$check_ip'";
            $fields[] = "check_host = '$check_host'";
            $fields[] = "check_thepss = '$sendpass'";
            $checkqry1 = "SELECT uid FROM {$user_prefix}_users WHERE (uname='" . $uname . "') OR (email='" . $email . "')";
            $checkqry2 = "SELECT uid FROM {$user_prefix}_users_temptable WHERE (uname='" . $uname . "') OR (email='" . $email . "')";
            $thecheckresult1 = sql_num_rows(sql_query($checkqry1));
            $thecheckresult2 = sql_num_rows(sql_query($checkqry2));
            if (($thecheckresult1) || ($thecheckresult2)) {
                mxErrorScreen(_ALREADY_EXIST);
                return;
            } else {
                $qry = "INSERT INTO {$user_prefix}_users_temptable SET " . implode(', ', $fields);
                $result = sql_query($qry);
                if (!$result) {
                    mxErrorScreen(_DATABASEERROR . " 101");
                    return;
                }
                mxSessionDelVar("vkpnewuser");
                $subject = $GLOBALS['sitename'] . " - " . _YA_REG_MAILSUB5 . " " . $uname;
                $buildlink = PMX_HOME_URL . "/modules.php?name=" . $module_name . "&op=a&c=" . $check_key . "&t=" . $check_time;
                $message = _YA_REG_MAILMSG5 . "\n\n" . $buildlink . "";
                mxMail($email, $subject, $message);

                include('header.php');
                title(_USERREGACT);
                userNavigation('register');
                echo '<div class="tabs-panel">';
                echo '<p class="bigger">' . _ACTLINKSENDED . '</p><br />' . $msg1 . '<br /><br />' . _THANKSUSER . ' ' . $GLOBALS['sitename'] . '!<br /><br />' . $msg3 ;
                if (MX_IS_ADMIN) {
                    echo '<hr /><p>the message (only for you as admin)</p>';
                    echo '<textarea cols="60" rows="15" style="width: 99%">' . $message . '</textarea>';
                }
                echo '</div>'; // tabs-panel
                include('footer.php');
                break;
            }
        default:

            $qry = "INSERT INTO {$user_prefix}_users SET " . implode(', ', $fields);
            $result = sql_query($qry);
            if (!$result) {
                mxErrorScreen(_DATABASEERROR);
                return;
            }
            mxSessionDelVar("vkpnewuser");

            $viewvars = mxStripSlashes($session);
            $viewvars['uid'] = sql_insert_id();

            sendnewusermail($viewvars);
            sendnewuserpm($viewvars);

            /* Modulspezifische Useranfgungen durchfuehren */
            pmx_run_hook('user.add', $viewvars['uid']);

            include('header.php');
            title(_USERREGLOGIN);
            userNavigation('register');
            echo '<div class="tabs-panel">';
            echo '<p class="bigger">' . _ACCOUNTCREATED . '</p>';
            echo '<p>' . $msg1 . '</p><p>' . _THANKSUSER . ' ' . $GLOBALS['sitename'] . '!</p><br /><p>' . $msg3 . '</p>';
            echo '</div>'; // tabs-panel
            include('footer.php');
            break;
    }
}

function sendnewusermail($userdata)
{
    $userconfig = load_class('Userconfig');
    // zusaetzliche optionale Ausgaben
    $optmessage = (function_exists("sendnewusermail_option")) ? sendnewusermail_option($userdata) : "";
    extract($userdata);
    $message = _WELCOMETO . " " . $GLOBALS['sitename'] . "!\n\n";
    $message .= _YOUUSEDEMAIL . " '" . $GLOBALS['sitename'] . "' " . _TOREGISTER . ".\n\n";
    switch ($userconfig->register_option) {
        case 0:
        case 1:
            // generiertes Passwort zusenden oder eigenes Passwort sofort freischalten
            $user_stat = 1;
            $subject = _YA_REG_MAILMSG4 . " " . $uname;
            $message .= _YA_FOLLOWINGMEM . "\n\n";
            $message .= "  -" . _NICKNAME . ":\t " . $uname . "\n";
            $message .= "  -" . _PASSWORD . ":\t " . $mailpass . "\n";
            $message .= "  -" . _EMAIL . ":\t " . $email . "\n";
            $message .= $optmessage;
            break;
        case 2:
            // generiertes Passwort zusenden, Adminfreischaltung
            $user_stat = 0;
            $subject = $GLOBALS['sitename'] . " - " . _YA_REG_MAILSUB2 . " " . $uname;
            $message .= _YA_FOLLOWINGMEM . "\n\n";
            $message .= "  -" . _NICKNAME . ":\t " . $uname . "\n";
            $message .= "  -" . _EMAIL . ":\t " . $email . "\n";
            $message .= $optmessage . "\n\n" . _YA_REG_MAILMSG2;
            break;
        case 3:
            // eigenes Passwort, Aktivierungslink zusenden
            $user_stat = 0;
            $subject = _YA_REG_MAILMSG4 . " " . $uname; //Changed here for Password-Mail at Reg-Option 3
            $message .= _YA_FOLLOWINGMEM . "\n\n"; //Changed here for Password-Mail at Reg-Option 3
            $message .= "  -" . _NICKNAME . ":\t " . $uname . "\n"; //Changed here for Password-Mail at Reg-Option 3
            $message .= "  -" . _PASSWORD . ":\t " . $mailpass . "\n"; //Changed here for Password-Mail at Reg-Option 3
            $message .= "  -" . _EMAIL . ":\t " . $email . "\n"; //Changed here for Password-Mail at Reg-Option 3
            $message .= $optmessage;
            break;
    }

    $message .= "\n\n\n\n" . $GLOBALS['slogan'] . "\n-----------------------------------------------------------\n\n";
    $message .= PMX_HOME_URL . "/modules.php?name=Your_Account";

    mxMail($email, $subject, $message);

    if ($userconfig->sendaddmail && (!($userconfig->register_option === 3))) { // Fix damit keine doppelte Mail an Admin
        $subject = _NEWMEMBERON . " " . $GLOBALS['sitename'] . ": " . $uname;
        $message = "\n" . _NEWMEMBERON . " '" . $GLOBALS['sitename'] . "'\n\n";
        $message .= " - " . _NICKNAME . ":\t " . $uname . "\n";
        $message .= " - " . _EMAIL . ":\t " . $email . "\n\n";
        $message .= " - ip:\t\t " . MX_REMOTE_ADDR . ((MX_REMOTE_HOST) ? ' (' . MX_REMOTE_HOST . ')' : '') . "\n";
        $message .= " - " . _ON . ":\t\t " . mx_strftime("%d-%m-%Y %H:%M:%S", time()) . "\n\n";
        $message .= $optmessage;
        $message .= "\n-----------------------------------------------------------\n\n";
        $message .= _NEWMEMBERINFO . ": " . PMX_HOME_URL . "/modules.php?name=Userinfo&uname=" . urlencode($uname) . "\n";
        $message .= _EDIT . ": " . PMX_HOME_URL . "/admin.php?op=modifyUser&chng_uid=" . $uid . "&user_stat=" . $user_stat . "\n";
        mxMail($GLOBALS['adminmail'], $subject, $message);
    }
}

/**
 * private Nachricht an neuen Benutzer senden
 */
function sendnewuserpm($userdata)
{
    $userconfig = load_class('Userconfig');
    if (!$userconfig->sendnewusermsg || !$userconfig->msgadminid) {
        return;
    }

    /* Sprachdatei auswaehlen */
    mxGetLangfile(PMX_MODULES_DIR . DS . $GLOBALS['module_name'] . DS . 'language', 'hello-*.php');

    $time = date("Y-m-d H:i");
    $subject = mxAddSlashesForSQL(mxHtmlEntityDecode(_HELLOSUBJECT1 . " " . $userdata['uname'] . ", " . _HELLOSUBJECT2 . " " . $GLOBALS['sitename']));
    $msg = mxAddSlashesForSQL(mxHtmlEntityDecode(_HELLOTEXT));

    $qry = "INSERT INTO " . $GLOBALS['tblprivatemessage'] . "
            (msg_image, subject, from_userid, to_userid, msg_time, msg_text) VALUES
            ('" . $userconfig->msgicon . "', '" . $subject . "', " . $userconfig->msgadminid . ", " . $userdata['uid'] . ", '" . $time . "', '" . $msg . "')";
    $result = sql_query($qry);
}

function account_linkactivate()
{
    global $user_prefix, $prefix, $module_name;

    switch (true) {
        case isset($_GET['c']):
            $thekey = intval($_GET['c']);
            $thetime = (isset($_GET['t'])) ? intval($_GET['t']) : 0;
            break;
        case isset($_GET['new_check']):
            // alte Links, vor 1.12
            $thekey = intval($_GET['new_check']);
            $thetime = (isset($_GET['new_time'])) ? intval($_GET['new_time']) : 0;
            break;
        default:
            $thekey = 0;
            $thetime = 0;
    }

    mxCheckUserTempTable(); // temporre Tabelle auf kompatibilitt pruefen und ggf. anpassen

    $readable_password = '';
    $query = "SELECT * FROM {$user_prefix}_users_temptable WHERE (check_key=" . $thekey . " AND check_time = " . $thetime . ")";
    $result = sql_query($query);
    if (sql_num_rows($result) != 1) {
        mxErrorScreen(_ACTIVEORDELETED, _DATABASEERROR, false);
        return;
    }
    $row = sql_fetch_assoc($result);
    if ($row['check_isactive']) {
        $qry = "DELETE FROM {$user_prefix}_users_temptable WHERE (check_key=" . $thekey . " AND check_time = " . $thetime . ")";
        sql_query($qry);
        mxErrorScreen(_ALREADYACTIVE, '', false);
        return;
    }
    $sqlvars = mxAddSlashesForSQL($row);
    extract($sqlvars);

    $exist = mxGetUserDataFromUsername($uname);
    if ($exist) {
        mxErrorScreen(_ALREADYACTIVE, '', false);
        return;
    }

    $readable_password = mxSecureValue(base64_decode($row['check_thepss']), true);

    $userconfig = load_class('Userconfig');
    switch ($userconfig->register_option) {
        case 3:
            $user_stat = 1;
            break;
        case 4:
            $user_stat = 0;
            break;
    }

    if (isset($uname)) $fields[0] = "uname = '$uname'";
    if (isset($pass)) $fields[1] = "pass = '$pass'";
    if (isset($email)) $fields[2] = "email = '$email'";
    if (isset($name)) $fields[3] = "name = '$name'";
    if (isset($url)) $fields[5] = "url = '" . mx_urltohtml($url) . "'";
    if (isset($user_regdate)) $fields[7] = "user_regdate = '$user_regdate'";
    if (isset($user_icq)) $fields[8] = "user_icq = '$user_icq'";
    if (isset($user_occ)) $fields[9] = "user_occ = '$user_occ'";
    if (isset($user_from)) $fields[10] = "user_from = '$user_from'";
    if (isset($user_intrest)) $fields[11] = "user_intrest = '$user_intrest'";
    if (isset($user_sig)) $fields[12] = "user_sig = '$user_sig'";
    if (isset($user_aim)) $fields[13] = "user_aim = '$user_aim'";
    if (isset($user_yim)) $fields[14] = "user_yim = '$user_yim'";
    if (isset($user_msnm)) $fields[15] = "user_msnm = '$user_msnm'";
    $fields[16] = "user_level = 1";
    if (isset($user_ingroup)) $fields[18] = "user_ingroup = $user_ingroup";
    if (isset($user_regtime)) $fields[19] = "user_regtime = $user_regtime";
    if (isset($user_stat)) $fields[20] = "user_stat = $user_stat";
    if (isset($user_sexus)) $fields[21] = "user_sexus = $user_sexus";
    if (isset($user_regtime)) $fields[22] = "user_lastvisit = $user_regtime";
    if (isset($userip)) $fields[23] = "user_lastip = '$userip'";
    if (isset($user_bday)) $fields[24] = "user_bday = '$user_bday'"; // ohne anfuehrz.

    if (function_exists("finishNewUser_option")) {
        // loeschen oder hinzufuegen von Insert-Elementen
        $fields = finishNewUser_option($row, $fields);
    }

    $qry = "INSERT INTO {$user_prefix}_users SET " . implode(', ', $fields);
    $result = sql_query($qry);
    if (!$result) {
        mxErrorScreen(_DATABASEERROR . " 'Insert from temptable into usertable'");
        return;
    }

    $query = "SELECT * FROM {$user_prefix}_users WHERE uid = " . intval(sql_insert_id());
    $result = sql_query($query);
    if (sql_num_rows($result) != 1) {
        mxErrorScreen(_ACTIVEORDELETED, _DATABASEERROR, false);
        return;
    }
    $the_needed_data = sql_fetch_assoc($result);

    /* Modulspezifische Useranfgungen durchfuehren */
    pmx_run_hook('user.add', $the_needed_data['uid']);

    sendnewuserpm($the_needed_data);

    if ($userconfig->sendaddmail) {
        $optmessage = (function_exists("sendnewusermail_option")) ? sendnewusermail_option($the_needed_data) : "";
        $subject = _NEWMEMBERON . " " . $GLOBALS['sitename'] . ": " . $uname;
        $message = "\n" . _NEWMEMBERON . " '" . $GLOBALS['sitename'] . "'\n\n";
        $message .= " - " . _NICKNAME . ":\t " . $uname . "\n";
        $message .= " - " . _EMAIL . ":\t " . $email . "\n\n";
        $message .= " - ip:\t\t " . MX_REMOTE_ADDR . ((MX_REMOTE_HOST) ? ' (' . MX_REMOTE_HOST . ')' : '') . "\n";
        $message .= " - " . _ON . ":\t\t " . mx_strftime("%d-%m-%Y %H:%M:%S", time()) . "\n\n";
        $message .= $optmessage;
        $message .= "\n-----------------------------------------------------------\n\n";
        $message .= _NEWMEMBERINFO . ": " . PMX_HOME_URL . "/modules.php?name=Userinfo&uname=" . urlencode($uname) . "\n";
        $message .= _EDIT . ": " . PMX_HOME_URL . "/admin.php?op=modifyUser&chng_uid=" . $the_needed_data['uid'] . "&user_stat=" . $user_stat . "\n";
        mxMail($GLOBALS['adminmail'], $subject, $message);
    }

    switch ($userconfig->register_option) {
        case 3:
            $delqry = "DELETE FROM {$user_prefix}_users_temptable WHERE (check_key=" . $thekey . " AND check_time = " . $thetime . ")";
            $delresult = sql_query($delqry);
            if (!$delresult) {
                mxErrorScreen(_DATABASEERROR . " 'Delete temptable - entry'");
                return;
            }
            $the_needed_data['mailpass'] = $readable_password; //Changed here for Password-Mail at Reg-Option 3
            sendnewusermail($the_needed_data); //Changed here for Password-Mail at Reg-Option 3
            // automatisches Login
            mxSetUserSession($the_needed_data["uid"], $the_needed_data["uname"], $the_needed_data["pass"], $the_needed_data["storynum"], $the_needed_data["umode"], $the_needed_data["uorder"], $the_needed_data["thold"], $the_needed_data["noscore"], $the_needed_data["ublockon"], $the_needed_data["theme"], $the_needed_data["commentmax"]);
            // Weiterleitung zu der in den Einstellungen definierten Seite
            mxRedirect($userconfig->yastartpage, _ACTSUCCESS);
            return;
        case 4:
            $query2 = "UPDATE {$user_prefix}_users_temptable SET check_isactive = 1 WHERE (check_key=" . $thekey . " AND check_time = " . $thetime . ")";
            $result2 = sql_query($query2);
            include_once('header.php');
            userNavigation('register');
            echo '<div class="tabs-panel">';
            echo '<br /><br />' . _ACTSUCCESS . '<br /><br />' . _WAITFORADMINACTION . "<br />\n<a href=\"./\">" . _HOME . "</a>\n";
            echo '</div>';
            include_once('footer.php');
            return;
    }
}

$op = (empty($_REQUEST['op'])) ? '' : $_REQUEST['op'];
switch ($op) {
    case "new_user":
        new_user();
        break;

    case "confirm":
        confirmNewUser($_POST);
        break;

    case "finish":
        finishNewUser();
        break;

    case "a":
    case "activate_account": // fr alte Links, vor 1.12
        account_linkactivate();
        break;
    default:
        new_user();
        break;
}

?>
