<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.12.6.17 $
 * $Author: tora60 $
 * $Date: 2012-03-05 12:55:55 $
 */

defined('mxMainFileLoaded') or die('access denied');
defined('mxYALoaded') or die('access denied');

/**
 * loginscreen()
 *
 * @return nothing
 */
function loginscreen()
{
    $oldvals = (is_array(mxSessionGetVar('formvalues'))) ? mxSessionGetVar('formvalues') : array();
    mxSessionDelVar('formvalues');

    switch (true) {
        case empty($_GET['stop']):
            $message = '';
            break;
        case defined('_YA_LOGINERR_' . intval($_GET['stop'])):
            $message = constant('_YA_LOGINERR_' . intval($_GET['stop']));
            break;
        default:
            $message = 'unknown error...';
    }

    include('header.php');
    title(_USERREGLOGIN);
    userNavigation('login');

    ?>
<div class="tabs-panel">
<?php if ($message): ?>
<div class="warning bigger"><?php echo $message ?></div>
<?php endif;

    ?>
<form action="modules.php?name=Your_Account" method="post" name="userlogin">
<br />
<p><?php echo _COOKIEWARNING ?></p>
<table class="form">
<tr><td><?php echo _NICKNAME ?>:&nbsp;&nbsp;</td><td><input type="text" name="uname" size="30" maxlength="25" value="<?php echo ((isset($oldvals['uname'])) ? $oldvals['uname'] : '') ?>" /></td></tr>
<tr><td><?php echo _PASSWORD ?>:&nbsp;&nbsp;</td><td><input type="password" name="pass" size="30" maxlength="20" /></td></tr>
<!--<tr><td>&nbsp;</td><td><input type="checkbox" value="1" name="rememberme" <?php echo((empty($oldvals['rememberme'])) ? '' : 'checked="checked"') ?> />&nbsp;<?php echo _REMEMBERLOGIN ?></td></tr>-->
<tr><td>&nbsp;</td><td><input type="submit" value="<?php echo _LOGIN ?>" /></td></tr>
</table><?php echo mxGetUserLoginCheckField() ?></form>
<script type="text/javascript"><!--document.userlogin.uname.focus();//--></script>
</div>
<?php
    include('footer.php');
}

/**
 * douserlogin()
 *
 * @param mixed $pvs
 * @return
 */
function douserlogin($pvs)
{
    global $user_prefix, $prefix;

    $defaults = array('check' => '', 'check_cookie' => '', 'name' => '', 'uname' => '', 'pass' => '');
    $pvs = array_merge($defaults, $pvs);

    if (MX_IS_USER) {
        session_write_close();
        mxRedirect(PMX_HOME_URL . '/modules.php?name=Your_Account');
        die();
    }

    $userconfig = load_class('Userconfig');

    if (isset($pvs['redirect'])) {
        $nexturl = $pvs['redirect'];
        unset($pvs['redirect']);
    } else {
        $nexturl = $userconfig->yastartpage;
    }

    $uloginreqcheck = mxSessionGetVar('uloginreqcheck');
    mxSessionDelVar('uloginreqcheck');
    mxSessionSetVar('formvalues', $pvs); // Werte zwischenspeichern, falls Fehler im Login
    $stop = 0;

    $pvs['check'] = (empty ($pvs['check'])) ? mt_rand() : $pvs['check']; // sicherstellen, dass $pvs['check'] initialisiert ist
    $pvs['check_cookie'] = (empty ($pvs['check_cookie'])) ? mt_rand() : $pvs['check_cookie']; // sicherstellen, dass $cookie_check initialisiert ist
    switch (true) {
        case empty($pvs['uname']):
        case empty($pvs['pass']):
            /* Loginname oder Passwort nicht angegeben */
            $stop = 3;
            break;
        case $pvs['check_cookie'] != MD5(session_id()):
            /* Verstecktes Formularfeld check_cookie entweder leer, verflscht oder nicht zur aktuellen Session passend.
             * Unautorisierter Loginversuch ber externes Formular, oder ungltige Session weil keine Cookies aktiviert, bzw. Cookie ungltig
             */
            $stop = 1;
            break;
        case $pvs['check'] != MD5($uloginreqcheck):
            /* Verstecktes Formularfeld check entweder leer, verflscht oder nicht zur aktuellen Session passend.
             * Unautorisierter Loginversuch ber externes Formular, oder ungltige Session weil keine Cookies aktiviert, bzw. Cookie ungltig
             */
            $stop = 2;
            break;
        case in_array(strtolower($pvs['uname']), mxGetCensorListUsers()):
            /* zensierter Benutzername angegeben */
            $stop = 11;
            break;
        default:
            $pvs['uname'] = trim(substr($pvs['uname'], 0, 25));
            $check_pass = md5($pvs['pass']);
    }

    if (!$stop) {
        /* Userdaten aus DB lesen */
        $dbdata = mxGetUserDataFromUsername($pvs['uname']);

        switch (true) {
            case !$dbdata:
            case empty($dbdata['uid']);
                /* Angegebener Username existiert nicht in der Datenbank */
                $stop = 4;
                break;
            case empty($dbdata['user_stat']):
                /* Useraccount neu, noch nicht aktiviert. */
                $stop = 6;
                break;
            case $dbdata['user_stat'] < 0:
                /* Useraccount ist gelscht. */
                $stop = 7;
                break;
            case $dbdata['user_stat'] == 2:
                /* Useraccount ist deaktiviert. */
                $stop = 9;
                break;
            case $dbdata['uname'] != $pvs['uname']:
                if ($GLOBALS['mxLoginCaseSensiTive']) {
                    /* Benutzername existiert, aber falsche Gross-Kleinschreibung */
                    $stop = 4;
                } else if (strtolower($dbdata['uname']) != strtolower($pvs['uname'])) {
                    /* Benutzername existiert, aber falsche Gross-Kleinschreibung */
                    $stop = 4;
                } else {
                    /* korrekte Gross-Kleinschreibung fr Loginnamen verwenden */
                    $pvs['uname'] = $dbdata['uname'];
                }
                break;
            case in_array(strtolower($pvs['uname']), mxGetCensorListUsers()):
                /* zensierter Benutzername angegeben */
                /* 2 mal stop 11, weil evtl. $pvs['uname'] inzwischen gendert wurde */
                $stop = 11;
                break;
            case $dbdata['pass'] != $check_pass:
                /* Passwort falsch. */
                $stop = 5;
                break;
            case mxSessionGetVar('user_uid') && mxSessionGetVar('user_uname'):
                /* prfen, ob die evtl. vorhandenen Sessiondaten mit den Logindaten bereinstimmen */
                if (mxSessionGetVar('user_uid') != $dbdata['uid'] || mxSessionGetVar('user_uname') != $dbdata['uname'] && empty($stop)) {
                    /* Es existiert bereits eine gltige Session mit anderen Userdaten. */
                    mxSessionDestroy();
                    $stop = 10;
                }
        }
    }

    if ($stop) {
        mxSessionSetVar('ucountbadlogin', intval(mxSessionGetVar('ucountbadlogin')) + 1);
        if (mxSessionGetVar('ucountbadlogin') >= 5) {
            mxSecureLog('SecLog', 'Bad Userlogin (' . $stop . ')- Account: ' . $pvs['uname']);
            mxSessionSetVar('ucountbadlogin', 3);
            $nexturl = 'modules.php?name=Your_Account&op=pass_lost&lost=' . $pvs['uname'];
        } else {
            $nexturl = 'modules.php?name=Your_Account&stop=' . $stop . '&bad=' . mxSessionGetVar('ucountbadlogin');
        }
    } else {
        mxSetUserSession($dbdata['uid'], $dbdata['uname'], $dbdata['pass'], $dbdata['storynum'], $dbdata['umode'], $dbdata['uorder'], $dbdata['thold'], $dbdata['noscore'], $dbdata['ublockon'], $dbdata['theme'], $dbdata['commentmax']);
        mxSessionDelVar('formvalues');
        mxSessionDelVar('ucountbadlogin');
        mxSessionDelVar('newusercheck'); // falls noch von Accounterstellung vorhanden
        mxSessionSetVar('lang', $dbdata['user_lang']);

        /* Modulspezifische Logins durchfuehren */
        pmx_run_hook('user.login', $dbdata['uid']);
    }
    session_write_close();
    return mxRedirect($nexturl);
}

/**
 * logout()
 *
 * @param mixed $delete
 * @return
 */
function logout($delete = false)
{
    global $prefix, $user_prefix, $currentlang;

    if (MX_IS_USER) {
        $udata = mxGetUserData();
        $qry = "UPDATE {$user_prefix}_users set user_lastvisit=" . time() . ", user_lastip='" . MX_REMOTE_ADDR . "', user_lastmod='logout' where uid=" . intval($udata['uid']);
        $result = sql_query($qry);
        if (MX_IS_ADMIN) {
            mxSessionSetVar('lasttime', 0); // Zurcksetzen, damit Online ausgefhrt wird
            mxSessionDelVar('user');
            mxSessionSafeCookie(MX_SAFECOOKIE_NAME_USER, 0);
            mxSetNukeCookie('user');
            session_write_close();
        } else {
            mxSessionDestroy();
        }

        /* Modulspezifische Logouts durchfuehren */
        pmx_run_hook('user.logout', $udata['uid']);
    }

    switch (true) {
        case $delete:
            return mxRedirect(PMX_HOME_URL . '/modules.php?name=Your_Account&op=deletefinisch&newlang=' . $currentlang);
        case isset($_REQUEST['redirect']):
            return mxRedirect($_REQUEST['redirect'] . ((strpos($_REQUEST['redirect'], '?') === false) ? '?' : '&') . 'newlang=' . $currentlang);
        default:
            return mxRedirect('modules.php?name=Your_Account&op=logoutfin&newlang=' . $currentlang);
    }
}

/**
 * logoutfinisch()
 *
 * @return
 */
function logoutfinisch()
{
    mxRedirect('index.php', _YOUARELOGGEDOUT);
}

?>